
;  rotary about arbitrary vector implemented by Maciej Guba,
;  macgub3@wp.pl , http://macgub.co.pl
;  ebx - normalized vector 3 dwords, each dword coefficient
;  esi - cosinus and sinus of angle
;  edi - desired matrix
make_arbitrary_mx:
 .nx      equ dword[ebx]
 .ny      equ dword[ebx+4]
 .nz      equ dword[ebx+8]
 .sinus   equ dword[esi]
 .cosinus equ dword[esi+4]
 fninit
 fld    dword[ebx]
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus ; dword[esi]
 faddp
 fstp   dword[edi]

 fld    .nx
 fmul   .ny
 fld    .cosinus
 fchs
 fld1
 faddp
 fmulp
 fld    .nz ;dword[ebx+8]
 fmul   .sinus  ;dword[esi]
; fchs
 faddp
 fstp   dword[edi+4]

 fld    .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   .sinus
 fchs
 faddp
 fstp   dword[edi+8]

 fld    .nx
 fmul   .ny
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .sinus
 fmul   .nz
 fchs
 faddp
 fstp   dword[edi+12]

 fld    .ny
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul   .cosinus
 faddp
 fstp   dword[edi+16]

 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .sinus
 fmul   .nx
; fchs
 faddp
 fstp   dword[edi+20]

 fld    .nx
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .ny
 fmul   .sinus
; fchs
 faddp
 fstp   dword[edi+24]

 fld    .ny
 fmul   .nz
 fld1
 fld    .cosinus
 fchs
 faddp
 fmulp
 fld    .nx
 fmul   .sinus
 fchs
 faddp
 fstp   dword[edi+28]

 fld    .nz
 fmul   st,st0
 fld    st
 fchs
 fld1
 faddp
 fmul  .cosinus
 faddp
 fstp  dword[edi+32]
ret



