sort_hybrid1:
; in:  esi - 1st table
;      edi - sec table
;      ecx - tables_units count - unit 8 bytes, sort key -> first unit dword
; out:
;      sorted first table
   push    ebp
   mov     ebp,esp
   .first_tab  equ  [ebp-4]
   .sec_tab    equ  [ebp-8]
   .units_cnt   equ [ebp-12]
   .endt       equ  [ebp-16]
  push         esi
  push         edi
  push         ecx
  sub          esp,4

  cmp          ecx,4
  jna           @f  ; .end
;   mov      esi,.tri_ch
;   mov      edi,.tri_ch1
;   mov      ecx,[triangles_count_var]
;   lea      ecx,[ecx*3]
   call     mix_tab
 @@:

   movd    xmm5,esp


   mov     esp,.sec_tab
   mov     ebx,.units_cnt
   shl     ebx,3
   add     esp,ebx

;   mov    eax,0
;   mov    ebx,.units_cnt
    mov    eax,1
    mov    ebx,.units_cnt
    dec    ebx


   movd   xmm7,.first_tab
   call   qsort_hybrid


   movd   esp,xmm5



;sort  again to be sure / its must  !!?
; next phase
if 1



   mov    ebx,.first_tab
   mov    ecx,.units_cnt  ;[triangles_count_var]
;   lea    ecx,[ecx*3]

   mov    esi,ecx
   shl    esi,3
   add    esi,ebx
   mov   .endt,esi

 .ccc:                                ; ebx    - vert index
   mov    eax,[ebx+8]                 ; ebx+4  - tri index
   cmp    eax,[ebx]
   jge    .g
   movq   xmm0,[ebx+8]
   push   ebx
 .c2:
   cmp    ebx,esi
   jae    .done
   cmp    ebx,.first_tab  ;tri_ch
   jb     .done
   cmp    eax,[ebx]
   jae    .done
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7
   sub    ebx,8
   jnc    .c2
   add    ebx,8
 .done:
   movq   [ebx+8],xmm0
 .p:
   pop    ebx
 .g:
   add    ebx,8
   dec    ecx
   cmp    ecx,1
   jnz    .ccc
end if
;  cmp   .fix_mark,0
;  jne   .do_ch
;    dbg_ptr .first_tab
  .end:
    mov esp,ebp
    pop ebp
ret



qsort_hybrid:
; sort only to cutoff moment - such pre sorted tab -
; - sort again using insert sort
; in:
;       eax - first
;       ebx - last
;       xmm6 - dim
;       xmm7 - table


  push  ebp
  mov   ebp,esp

 .i     equ dword[ebp-4]
 .last  equ dword[ebp-8]
 .first equ dword[ebp-12]
 .j     equ dword[ebp-16]


  push  eax
  push  ebx
  push  eax
  push  ebx
  mov   edx,ebx
  sub   edx,eax
  cmp   edx,5
  jl    .nxp          ; time to next phase sorting
                       ; not now
  movd  esi,xmm7  ;.tabl
  shl   eax,3
  shl   ebx,3
  mov   edx,[esi+eax]
  add   edx,[esi+ebx]
  shr   edx,1

  mov   ecx,.i
;  mov   ebx,.j
  pop   ebx
 .nnnx:

  cmp   ecx,ebx  ;.j
  jnle  .srt
     movd  esi,xmm7  ;.tabl
     mov   eax,ecx   ;.i
     shl   eax,3
     add   esi,eax
     dec   ecx
     sub   esi,8
    @@:
     add   esi,8
     inc   ecx  ;.i
     cmp   [esi],edx  ;.pivot
     jl    @b

     movd  edi,xmm7
     mov   eax,ebx  ;.j
     shl   eax,3
     add   edi,eax
     add   edi,8
     inc   ebx
    @@:
     sub   edi,8
     dec   ebx   ;.j
     cmp   [edi],edx  ;.pivot
     jg    @b

     cmp   ecx,ebx  ;.j
     jnle  @f           ;  jg   ??
     movq  xmm0,[esi]
     movq  xmm1,[edi]
     movq  [esi],xmm1
     movq  [edi],xmm0
     inc   ecx  ;.i
     dec   ebx  ;.j
    @@:
     jmp    .nnnx
 .srt:
   mov    .i,ecx
;   mov    .j,ebx
   push   ebx
   mov    eax,.first
   cmp    eax,ebx  ;.j
   jge    @f
;   add    esp,8
   call   qsort_hybrid
 @@:
   mov    eax,.i
   cmp    eax,.last
   jge    @f
   mov    ebx,.last
   call   qsort_hybrid
 @@:
 .nxp:

   mov  esp,ebp
   pop  ebp
ret



mix_tab:
; in:
;      esi - in tab
;      edi - out tab
;      ecx - unit number, unit 8 bytes
   push   ebp
   mov    ebp,esp

   .dst   equ dword[ebp-4]
   .src   equ dword[ebp-8]
   .cnt   equ dword[ebp-12]
   .cnt1  equ dword[ebp-16]
   .rest  equ dword[ebp-20]


   push   edi
   push   esi
   push   ecx


   mov    eax,ecx
   shr    eax,2
   push   eax
   and    ecx,11b
   push   ecx

   mov    ecx,6
 .lll:
   push   ecx
   mov    edi,.dst
   mov    esi,.src
   mov    ecx,.cnt1

   shl    ecx,3
   lea    eax,[esi+ecx]
   lea    ebx,[esi+ecx*2]
   lea    edx,[eax+ecx*2]
   mov    ecx,.cnt1
 @@:
   movlps   xmm0,[esi]
   movhps   xmm0,[eax]
   movlps   xmm1,[ebx]
   movhps   xmm1,[edx]

   movaps   [edi],xmm0
   movaps   [edi+16],xmm1
   add      esi,8
   add      eax,8
   add      ebx,8
   add      edx,8
   add      edi,32
   loop     @b

   mov      ecx,.rest
   jecxz    .ll2
  @@:
   movq     xmm0,[edx]
   movq     [edi],xmm0
   add      edx,8
   add      edi,8
   loop     @b

  .ll2:
   pop      ecx

   push     .dst  ; swap
   push     .src
   pop      .dst
   pop      .src

   loop     .lll

   mov      esp,ebp
   pop      ebp
ret
