save_chunks_file:
    push   ebp
    mov    ebp,esp
    sub    esp,4

    .file_handle   equ [ebp-4]

    cmp  [chunks_ptr],0
    je   @f
    invoke    CreateFile,Chfile_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov       .file_handle,eax
    mov       ecx,[triangles_count_var]
    add       ecx,ecx
    invoke    WriteFile,eax,[chunks_ptr],ecx,byteswritten, 0
    invoke    CloseHandle,.file_handle
 ;   invoke    VirtualFree,[chunks_ptr],0 , MEM_RELEASE
   @@:
    mov    esp,ebp
    pop    ebp
ret
save3ds:
   pushad
   mov    ebp,esp
   sub    esp,16

    .3dbuffer_ptr    equ [ebp-4]
    .file_handle   equ [ebp-8]
    .bytes_written equ [ebp-12]
    .file_size     equ [ebp-16]
   mov     eax,[points_count_var]
   add     eax,[triangles_count_var] ; to big mem, I know
   add     eax,100
   imul    eax,[i12]
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov    .3dbuffer_ptr,eax

    mov   edi,eax
    mov   [edi],word 4d4dh
    add   edi,6
    mov   [edi],word 3d3dh
    add   edi,6
    mov   [edi],word 4000h
    add   edi,6
    mov   [edi],byte 0
    inc   edi
    mov   [edi],word 4100h     ;    [global_points_counter]
    add   edi,6
    mov   [edi],word 4110h
    mov   ecx,[points_count_var]

    mov   edx,ecx
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[points_rotated_ptr];   [points_r_ptr]   ;
    xor   ebx,ebx
    lea   ecx,[ecx*3]
  @@:
    rep   movsd
    mov   [edi],word 4120h
    mov   ecx,[triangles_count_var]
    mov   [edi+6],cx
    add   edi,8
    mov   esi,[triangles_ptr]
    cld
  @@:
    movdqu    xmm0,[esi]
    packssdw  xmm0,xmm0
    movq      [edi],xmm0
    mov       dword[edi+6],0
    add       esi,12
    add       edi,8
    loop      @b
    mov       ebx,.3dbuffer_ptr
    sub       edi,.3dbuffer_ptr
    mov       [ebx+2],edi
    mov       .file_size,edi
    invoke    CreateFile,Bfile_name, GENERIC_WRITE, 0, 0,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, 0
    mov       .file_handle,eax
    invoke    WriteFile,eax,.3dbuffer_ptr,.file_size,byteswritten, 0
    invoke    CloseHandle,.file_handle
    invoke    VirtualFree,.3dbuffer_ptr,0 , MEM_RELEASE

    mov       esp,ebp
    popad
ret
