call_thread1:
; in eax  - proc-th adress
;    edx -  param bitewise 'and' with param passed to proc_th
;    ecx -  max thread count, if -1 no in use

     push   ebp
     mov    ebp,esp

     push   edx
     push   eax
     push   ecx

     .par1   equ dword[ebp-4]
     .procTh equ dword[ebp-8]
     .maxTh  equ dword[ebp-12]

     mov    ebx,4
     cmp    ecx,-1
     cmove  ecx,ebx
     mov    .maxTh,ecx

     xor    ebx,ebx
   .th_l:
     push   ebx
     mov    eax,ebx
     or     eax,.par1

     invoke CreateThread,NULL,NULL,.procTh,\
            eax,NORMAL_PRIORITY_CLASS,\
            [ThreadID0+ebx*4]
     shl    ebx,2
     add    ebx,hthread0
     mov    [ebx],eax
     invoke SetThreadPriority,ebx,THREAD_PRIORITY_TIME_CRITICAL
     pop    ebx
     inc    ebx
     cmp    ebx,4
     jne    .th_l

     xor    ebx,ebx
   @@:
     invoke SetThreadAffinityMask,[hthread0+ebx*4],0 ;1
     inc    ebx
     cmp    ebx,4
     jne    @b

     xor    ebx,ebx
   @@:
     invoke ResumeThread,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b

     invoke WaitForMultipleObjectsEx,4,hthread0,1,-1,0

     xor    ebx,ebx
   @@:
     invoke CloseHandle,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b


    mov     esp,ebp
    pop     ebp
ret

;======================================================================================
if 0      ; not correct
smooth_ed_iv_ie:
; Smooth inside edges with at last one inside vertex and
; at last one collided edge - edge that intersect any other triangle
; Before calling procedure colided edges list and inside vertices list
; must be corrected calculated. If this proc dont works as expected,
; try other algo proc - under 'Sm ins ed' button.

; in  esi - ptr to inside vertices mask list
; out:  corrected vertices ( list addres [points_r_ptr] )

   .in_vr          equ dword[ebp-4]  ; ptr to inside vertices list
                                     ; if correspond bit is zeroed ->
                                     ; -> vertex is inside object
   .index_vr       equ dword[ebp-8]
   .org            equ [ebp-32]
   .dir            equ [ebp-48]
   .index_vr2      equ [ebp-12]
   .len            equ [ebp-16]

   push     ebp
   mov      ebp,esp
   sub      esp,64
   and      ebp,-16

   mov     .in_vr,esi

 ;  prompt   prompt_tes_tiv


   xor    ecx,ecx
 .main_loop:       ; search for inside vertex
   push   ecx
   mov    esi,ecx
   mov    ebx,ecx
   shr    esi,3
   and    ebx,111b
   add    esi,.in_vr
   bt     [esi],ebx
   jnc    @f
 .end_m_loop:
   pop    ecx
   inc    ecx
   cmp    ecx,[points_count_var]
   jne    .main_loop
   jmp    .end


 @@:
   movd    xmm3,ecx

   mov     .index_vr,ecx
   pshufd  xmm3,xmm3,0


   mov       esi,[edges_ptr] ; check if this vertex is in any
   xor       edx,edx         ; edge that intersect
  .chck_ed:
   movq      xmm1,[esi]
   movq      xmm2,[esi]
   pcmpeqd   xmm1,xmm3
   movmskps  eax,xmm1
   or        eax,eax
   jnz       .fe
 .end_chck_ed:
   add       esi,8
   add       edx,1
   cmp       edx,[edges_count]
   jna       .chck_ed
   jmp       .end_m_loop

 .fe:
    movd      .index_vr2,xmm2
    cmp       eax,1b
    jne       @f
    psrldq    xmm2,4
    movd      .index_vr2,xmm2
  @@:
;   and       eax,11b
;   or        eax,eax
;   jnz       .found_ed1

;   inc       edx
;   movhlps   xmm4,xmm2
;   jmp       .fx
; .found_ed1:
;   movq      xmm4,xmm2
;  .fx:
;   movd      eax,xmm4
;   mov       .index_vr2,eax
;   cmp       eax,.index_vr
;   jne       @f
;   pshufd    xmm4,xmm4,11100001b
;   movd      .index_vr2,xmm4
;  @@:
;   pshufd    xmm4,xmm4,00010100b   ; xmm3 - edge
   mov       ebx,edx
   mov       edi,edx
   and       ebx,111b
   shr       edi,3
   add       edi,[edges_intersect_ptr]
   bt        [edi],ebx
   jnc        .end_chck_ed
; Intersected tri calling params
; in:
;     xmm0 - ray direction  ; should be normalized
;     xmm1 - ray orgin
;     xmm2 - tri vert1
;     xmm3 - tri vert2
;     xmm4 - tri vert3
;     if  eax = 1 - intersction with edge
;        xmm6 - edge lenght
;     if  eax = 0 - intersect with ray (classic)
; out:
;     eax  = 1 - intersection occured
;     xmm0 - float lo -> hi = t, v, u, ...

   mov       eax,.index_vr
   mov       ebx,.index_vr2
   imul      eax,[i12]
   imul      ebx,[i12]
   add       eax,[points_r_ptr]
   add       ebx,[points_r_ptr]
   movups    xmm0,[eax]
   movups    xmm1,[ebx]
   subps     xmm1,xmm0
   andps     xmm0,[zero_hgst]
   andps     xmm1,[zero_hgst]
   movaps    xmm2,xmm1
 ; normalise vector
   mulps     xmm1,xmm1
   haddps    xmm1,xmm1
   haddps    xmm1,xmm1
   sqrtps    xmm6,xmm1
   rcpps     xmm1,xmm6
   mulps     xmm1,xmm2
   movaps    .dir,xmm1
   movaps    .org,xmm0
   movss     .len,xmm6


   xor       ecx,ecx
   mov       esi,[triangles_ptr]
 .ll:                 ; search for tri this ed intersect
   mov       eax,[esi]
   mov       ebx,[esi+4]
   mov       edx,[esi+8]
   imul      eax,[i12]
   imul      ebx,[i12]
   imul      edx,[i12]
   add       eax,[points_r_ptr]
   add       ebx,[points_r_ptr]
   add       edx,[points_r_ptr]

   movups    xmm2,[eax]
   movups    xmm3,[ebx]
   movups    xmm4,[edx]
   movaps    xmm0,.dir
   movaps    xmm1,.org
   andps     xmm2,[zero_hgst]
   andps     xmm3,[zero_hgst]
   andps     xmm4,[zero_hgst]
   movss     xmm6,.len

   mov       eax,1
   push      ecx
   push      esi
   call      intersect_tri
   pop       esi
   pop       ecx
   cmp       eax,1
   je        .inter
   add       esi,12
   inc       ecx
   cmp       ecx,[points_count_var]
   jne       .ll
   jmp       .end_m_loop

 .inter:

   shufps    xmm0,xmm0,0    ; t
   mulps     xmm0,.dir
   mov       eax,.index_vr  ;  index of inside vertex
   imul      eax,[i12]
   add       eax,[points_r_ptr]
   movaps    xmm1,.org
   addps     xmm1,xmm0
   movlps    [eax],xmm1
   movhlps   xmm1,xmm1
   movss     [eax+8],xmm1
   jmp       .end_m_loop

 .end:

   add    esp,64
   pop    ebp

ret
end if

;=================================================================
teslate_tiv:
; teslate triangles with at last one inside vertex and at last
; one edge that intersect any other tri.
; in:  esi - ptr to inside vertices mask list
;      ecx - inner vertices number
;      ebx - col edges count
; out: corected triangles and vertices list
   push  ebp
   mov   ebp,esp
   sub   esp,180
   and   ebp,-16

   .in_vr     equ dword[ebp-4]  ; ptr to inside vertices list
                                ; if correspond bit is zeroed ->
                                ; -> vertex is inside object
   .in_vr_numb     equ dword[ebp-8]

   .new_points_ptr equ dword[ebp-12]
   .new_tris_ptr   equ dword[ebp-16]
   .new_vert       equ dword[ebp-20] ; number of new
   .new_tris       equ dword[ebp-24]
   .vert1          equ [ebp-48]
   .vert2          equ [ebp-64]
   .vert3          equ [ebp-80]
   .mid1           equ [ebp-96]
   .mid2           equ [ebp-112]
   .curInV         equ [ebp-128]
   .curEdV1        equ [ebp-144]
   .curEdV2        equ [ebp-160]




   emms
   cmp     ecx,ebx
   ja      @f
   mov     ecx,ebx  ; choose max
 @@:
   mov    .in_vr,esi
   mov    .in_vr_numb,ecx


   prompt   prompt_tes_tiv

   mov    .new_vert,0
   mov    .new_tris,0


   imul    ecx,[i36]    ; max 12 new vertices per inner vert
   shl     ecx,1
   add     ecx,20
   push    ecx
   invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .new_points_ptr,eax

;   mov     ecx,.clid_ed_numb
;   imul    ecx,[i12]    ; max six new tris per per inner vert
;   add     ecx,20
   pop     ecx
   invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .new_tris_ptr,eax

   xor    ecx,ecx
 .main_loop:
   push   ecx
   mov    esi,ecx
   mov    ebx,ecx
   shr    esi,3
   and    ebx,111b
   add    esi,.in_vr
   bt     [esi],ebx
   jnc    .in_v_f
 .end_m_loop:
   pop    ecx
   inc    ecx
   cmp    ecx,[points_count_var]
   jne    .main_loop
   jmp    .end

 .in_v_f:
   movd    xmm3,ecx
   pshufd  xmm3,xmm3,0
   movaps  .curInV,xmm3  ; current insiede vert


   mov       esi,[edges_ptr] ; check edge
   xor       edx,edx
  .chck_ed:          ; one edge for time
   push      edx
   push      esi
   movq      xmm1,[esi]
   movq      xmm2,[esi]

   pcmpeqd   xmm1,.curInV
   movmskps  eax,xmm1
;   mov       ebx,eax
;   shr       ebx,2
   and       eax,11b
   or        eax,eax
   jnz       .found_ed1
;   or        ebx,ebx
;   jnz       .found_ed2
 .end_chck_ed:
   pop       esi
   pop       edx
   add       esi,8
   add       edx,1
   cmp       edx,[edges_count]
   jna       .chck_ed
   jmp       .end_m_loop

; .found_ed2:
;   inc       edx
;   movhlps   xmm3,xmm2
;   jmp       .fx
 .found_ed1:
   movq      xmm3,xmm2
;  .fx:
   pshufd    xmm3,xmm3,0 ;00010100b   ; xmm3 - edge
   pshufd    xmm2,xmm2,01010101b
   movaps    .curEdV1,xmm3
   movaps    .curEdV2,xmm2
   mov       ebx,edx
   mov       edi,edx
   and       ebx,111b
   shr       edi,3
   add       edi,[edges_intersect_ptr]
   bt        [edi],ebx
   jnc       .end_chck_ed



   xor       edx,edx  ; search in triangles list
   mov       esi,[triangles_ptr]
  .chck_tri:
   push      edx
   push      esi
   movdqu    xmm4,[esi]
   movdqu    xmm0,[esi]
   pcmpeqd   xmm4,.curEdV1
   pcmpeqd   xmm0,.curEdV2
   por       xmm4,xmm0
   movmskps  eax,xmm4
   and       eax,111b
   or        eax,eax
   jnz       .tes
 .end_chck_tri:
   pop       esi
   pop       edx
   add       esi,12
   inc       edx
   cmp       edx,[triangles_count_var]
   jnz       .chck_tri
   jmp       .end_chck_ed

  .tes:   ; esi - ptr to triangle
   mov       eax,[esi]    ; teslate this tri
   mov       ebx,[esi+4]
   mov       edx,[esi+8]
   imul      eax,[i12]
   imul      ebx,[i12]
   imul      edx,[i12]
   add       eax,[points_r_ptr]
   add       ebx,[points_r_ptr]
   add       edx,[points_r_ptr]
   movups    xmm5,[eax]
   movups    xmm6,[ebx]
   movups    xmm7,[edx]
   movaps    xmm4,xmm5
   addps     xmm5,xmm6
   addps     xmm6,xmm7
   addps     xmm4,xmm7
   mulps     xmm5,[f05x3] ; three new vertices
   mulps     xmm6,[f05x3]
   mulps     xmm4,[f05x3]
   movaps    .vert1,xmm5
   movaps    .vert2,xmm6
   movaps    .vert3,xmm4

   movd      mm4,[abs_z_coof]  ; mark empty
   movd      mm5,[abs_z_coof]
   movd      mm6,[abs_z_coof]

   cmp       .new_vert,0
   je        .store
   cmp       .new_tris,0
   je        .store

   ; check if vertices are previously stored on list
   mov       ecx,.new_tris
   mov       edi,.new_tris_ptr
   add       edi,8     ; old vert index always on thrid position: [edi+8]

  .chck_inx:
   push      ecx
   push      edi

   movd      mm0,[edi]
   movd      mm1,[esi]
   movd      mm2,[esi+4]
   movd      mm3,[esi+8]
   pcmpeqd   mm1,mm0 ;[edi]
   pcmpeqd   mm2,mm0 ;[edi]
   pcmpeqd   mm3,mm0 ;[edi]
   por       mm1,mm2
   por       mm1,mm3
   movd      eax,mm1
   or        eax,eax
   jnz       .ind_f        ; index is already on list
  .l_chck_inx_end:

   pop       edi
   pop       ecx
   add       edi,12
   loop      .chck_inx
   jmp       .store

  .ind_f:             ; ecx - index of index of vert in .new_tri_ptr list
   sub       edi,8
   ; [edi]   - new vertex
   ; [edi+4] - new vert
   ; [edi+8] - old vert
   mov       ecx,2
  .ind_ff:
;   int3
   mov       eax,[edi]
   sub       eax,[points_count_var]
   imul      eax,[i12]
   add       eax,.new_points_ptr
   movups    xmm7,[eax]
   movups    xmm0,[eax]
   addps     xmm7,[eps2]
   subps     xmm0,[eps2]
   movaps    .mid1,xmm7
   movaps    .mid2,xmm0
   cmpltps   xmm7,.vert1
   cmpltps   xmm0,.vert1
   xorps     xmm7,xmm0
   movmskps  ebx,xmm7
   and       ebx,111b
   or        ebx,ebx
   jnz       .this_one


   movaps    xmm7,.mid1
   movaps    xmm0,.mid2
   cmpltps   xmm7,.vert2
   cmpltps   xmm0,.vert2
   xorps     xmm7,xmm0
   movmskps  ebx,xmm7
   and       ebx,111b
   or        ebx,ebx
   jnz       .this_one1

   movaps    xmm7,.mid1
   movaps    xmm0,.mid2
   cmpltps   xmm7,.vert3
   cmpltps   xmm0,.vert3
   xorps     xmm7,xmm0
   movmskps  ebx,xmm7
   and       ebx,111b
   or        ebx,ebx
   jnz       .this_one2
 .ind_ff_end:
   add       edi,4
   dec       ecx
   jnz      .ind_ff
   jmp      .l_chck_inx_end
   int3  ; sth wrong


 .this_one:
   movd      mm4,[edi]
;   jmp       .l_chck_inx_end
   jmp       .ind_ff_end
 .this_one1:
   movd      mm5,[edi]
;   jmp       .l_chck_inx_end
   jmp       .ind_ff_end
 .this_one2:
   movd      mm6,[edi]
;   jmp       .l_chck_inx_end
   jmp       .ind_ff_end


 .store:
   movd      mm1,[esi]
   movd      mm2,[esi+4]
   movd      mm3,[esi+8]
   mov       ebx,.new_vert
   mov       edi,.new_vert
   add       ebx,[points_count_var]
   imul      edi,[i12]
   add       edi,.new_points_ptr
   movd      eax,mm4
   cmp       eax,-1      ; before check if mm4 - mm6 was prev written
   jne       @f
   movups    [edi],xmm5        ; save new vertices to list
   add        edi,12
   movd       mm4,ebx
   inc        ebx
 @@:
   movd      eax,mm5
   cmp       eax,-1
   jne       @f
   movups    [edi],xmm6        ; save new vertices to list
   add        edi,12
   movd       mm5,ebx
   inc        ebx
 @@:
   movd      eax,mm6
   cmp       eax,-1
   jne       @f
   movups    [edi],xmm4        ; save new vertices to list
   add       edi,12
   movd      mm6,ebx
   inc       ebx
 @@:
   sub       ebx,[points_count_var]
   mov       .new_vert,ebx

   ; determine new tris

  ; mm1 - mm6 registers - indexes of vertices

   mov       edi,.new_tris ; new tri number
   imul      edi,[i12]
   add       edi,.new_tris_ptr
   ; dword[esi] - old tri place

   movd     [esi],mm4
   movd     [esi+4],mm5
   movd     [esi+8],mm6
                               ;           1
   movd     [edi],mm5          ;          / \
   movd     [edi+4],mm4        ;         /   \
   movd     [edi+8],mm2        ;        /     \
                               ;       4-------6
                               ;      / \    /  \
                               ;     /   \  /    \
   movd     [edi+12],mm4       ;    2------5-----3
   movd     [edi+16],mm6
   movd     [edi+20],mm1

   movd     [edi+24],mm6
   movd     [edi+28],mm5
   movd     [edi+32],mm3
   add      .new_tris,3
   jmp      .end_chck_tri

  .end:
   mov      ecx,[points_count_var]
   add      ecx,.new_vert
   imul     ecx,[i12]
   add      ecx,20
   invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   push    eax
   mov     edi,eax

   mov     esi,[points_r_ptr]
   mov     ecx,[points_count_var]
   lea     ecx,[ecx*3+3]
   shr     ecx,2
  @@:
   movaps  xmm0,[esi]
   movaps  [edi],xmm0
   add     esi,16
   add     edi,16
   loop    @b
;   lea     ecx,[ecx*3] ; my Windows 7 bit patched by M$ version
;   cld                 ; don't accept this rep movsd chain function
;   rep     movsd
   mov     edi,[points_count_var]
   imul    edi,[i12]
   add     edi,eax
   mov     esi,.new_points_ptr
   mov     ecx,.new_vert
 @@:
   movups  xmm0,[esi]
   movups  [edi],xmm0
   add     esi,12
   add     edi,12
   loop    @b

;   lea     ecx,[ecx*3]
;   rep     movsd
   invoke  VirtualFree,[points_r_ptr] ,0,MEM_RELEASE



   pop     [points_r_ptr]
   mov     ecx,.new_vert
   add     [points_count_var],ecx


   mov      ecx,[triangles_count_var]
   add      ecx,.new_tris
   imul     ecx,[i12]
   add      ecx,20
   invoke   VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   push     eax
   mov      edi,eax

   mov     esi,[triangles_ptr]

   mov     ecx,[triangles_count_var]
   lea     ecx,[ecx*3+3]
   shr     ecx,2
;   lea     ecx,[ecx*3]
;   cld
;   rep     movsd
  @@:
   movaps  xmm0,[esi]
   movaps  [edi],xmm0
   add     esi,16
   add     edi,16
   loop    @b

   mov     edi,[triangles_count_var]
   imul    edi,[i12]
   add     edi,eax
   mov     esi,.new_tris_ptr
   mov     ecx,.new_tris
;   lea     ecx,[ecx*3]
;   rep     movsd

  @@:
   movups  xmm0,[esi]
   movups  [edi],xmm0
   add     esi,12
   add     edi,12
   loop    @b


   invoke  VirtualFree,[triangles_ptr] ,0,MEM_RELEASE
   invoke  VirtualFree,.new_points_ptr ,0,MEM_RELEASE
   invoke  VirtualFree,.new_tris_ptr,0,MEM_RELEASE

   pop     [triangles_ptr]
   mov     ecx,.new_tris
   add     [triangles_count_var],ecx

   cls

   add     esp,180
   pop     ebp

ret


;=============================================================================

del_tiv_ie_without:
;   delete triangles with at last one inside vertex,
;   and without intersecting edges.
; in:  esi - ptr to inside vertices mask list
;      ebx - ptr to intersecting edges mask list
; out: corrected triangles list.

   push  ebp
   mov   ebp,esp

   .in_vr     equ dword[ebp-4]  ; ptr to inside vertices list
                                ; if correspond bit is zeroed ->
                                ; -> vertex is inside object

   .clidd_ed  equ dword[ebp-8]  ; ptr to colidded edges list
                                ; each bit in list -> edge
   push   esi                   ; if bit is set->  edge intersect
   push   ebx


   xor   ecx,ecx
 .main_loop:
   push  ecx
   mov   esi,ecx
   mov   ebx,ecx
   shr   esi,3
   and   ebx,111b
   add   esi,.in_vr
   bt    [esi],ebx
   jc    .nx_ed

   movd     xmm0,ecx      ; vert inside, check if tri has edge that intersect
   pshufd   xmm0,xmm0,0
   mov      esi,[triangles_ptr]
   xor      edx,edx
  .nx_tri_loop:
   movups   xmm1,[esi]
   pcmpeqd  xmm1,xmm0   ; xmm0 - broadcasted vert index
   movmskps eax,xmm1
   and      eax,111b
   or       eax,eax
   jnz      @f
  .ntri:
   inc      edx
   add      esi,12
   cmp      edx,[triangles_count_var]
   jnz      .nx_tri_loop
   jmp      .nx_ed

  @@:
   ; tri found
if 0
   mov      eax,[esi]
   mov      ebx,[esi+4]
   mov      ecx,[esi+8]
   cmp      eax,ebx
   jg       @f
   xchg     eax,ebx
  @@:
   cmp      eax,ecx
   jg       @f
   xchg     eax,ecx
  @@:
   cmp      ebx,ecx
   jg       @f
   xchg      ebx,ecx
   movd     xmm1,eax
   movd     xmm2,ebx
   movd     xmm3,ecx
   pshufd   xmm1,xmm2,0
   pshufd   xmm2,xmm3,0
   pshufd   xmm3,xmm1,0
   pshufd   xmm1,xmm1,00001100b
   pshufd   xmm2,xmm2,00001100b
   pshufd   xmm3,xmm3,00001100b
   movlhps  xmm1,xmm2
end if
   movdqu   xmm1,[esi]
   movdqu   xmm2,[esi]
   movdqa   xmm3,xmm1
   pshufd   xmm1,xmm1,01000001b
   pshufd   xmm2,xmm2,10000010b
   pshufd   xmm3,xmm3,01101001b

   xor      ecx,ecx
   mov      edi,[edges_ptr]
 .check:
   movq     xmm4,[edi]
   pshufd   xmm4,xmm4,01000100b
   movdqa   xmm5,xmm4
   movdqa   xmm6,xmm4
   pcmpeqd  xmm4,xmm1
   pcmpeqd  xmm5,xmm2
   pcmpeqd  xmm6,xmm3

   movmskps eax,xmm4
   mov      ebx,eax
   and      eax,11b
   shr      ebx,2
   cmp      ebx,11b
   jz       .ed_found
   cmp      eax,11b
   jz       .ed_found
   movmskps eax,xmm5
   mov      ebx,eax
   and      eax,11b
   shr      ebx,2
   cmp      ebx,11b
   jz       .ed_found
   cmp      eax,11b
   jz       .ed_found
   movmskps eax,xmm6
   mov      ebx,eax
   and      eax,11b
   shr      ebx,2
   cmp      ebx,11b
   jz       .ed_found
   cmp      eax,11b
   jz       .ed_found

;   popcnt   eax,eax
;   cmp      eax,2
;   jz       .ed_found
;   movmskps eax,xmm5
;   popcnt   eax,eax
;   cmp      eax,2
;   jz       .ed_found
;   movmskps eax,xmm6
;   popcnt   eax,eax
;   cmp      eax,2
;   jz       .ed_found
  .no_int_ed:
   add      edi,8
   inc      ecx
   cmp      ecx,[edges_count]
   jnz      .check

  ; now all edges was checked no one intersect,so we mark triangle
   movq     [esi],xmm0
   movd     [esi+8],xmm0
 ; no forget about removing dead ris from list in the end of proc !!
   jmp      .ntri  ; Did any another tri with inside
                  ; vert and without intersect ed exist ?    ;.nx_ed

   .ed_found:
   mov      ebx,ecx
   mov      eax,ecx
   and      ebx,111b
   shr      eax,3
   add      eax,.clidd_ed
   bt       [eax],ebx
   jnc      .no_int_ed   ; this ed no intersect

  .nx_ed:
   pop      ecx
   inc      ecx
   cmp      ecx,[points_count_var]
   jnz      .main_loop

   call    remove_dead_tri

   mov     esp,ebp
   pop     ebp
ret

;================================================================================
clip_triangles:
; clipping triangles not beeing in teslate area
   push  ebp
   mov   ebp,esp
   sub   esp,12
   .tri_ptr equ dword[ebp-4]
   .cntt     equ dword[ebp-8]

   mov     eax,[triangles_count_var]
   imul    eax,[i12]
   add     eax,20
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_ptr,eax

   mov     edi,eax
   mov     esi,[triangles_ptr]
   mov     ecx,[triangles_count_var]
   mov    .cntt,0
  .l:
   mov     eax,[esi]
   mov     ebx,[esi+4]
   mov     edx,[esi+8]
   imul    eax,[i12]
   imul    ebx,[i12]
   imul    edx,[i12]
   add     eax,[points_rotated_ptr]
   add     ebx,[points_rotated_ptr]
   add     edx,[points_rotated_ptr]
   movlps  xmm0,[eax]
   movlps  xmm1,[ebx]
   movlps  xmm2,[edx]
   movlhps xmm0,xmm0
   movlhps xmm1,xmm1
   movlhps xmm2,xmm2
   cmpltps xmm0,[tri_area_x1]
   cmpltps xmm1,[tri_area_x1]
   cmpltps xmm2,[tri_area_x1]
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   xorps   xmm0,xmm3
   xorps   xmm1,xmm4
   xorps   xmm2,xmm5
   pand    xmm0,xmm1
   pand    xmm0,xmm2
   movmskps eax,xmm0
   and     eax,11b
   cmp     eax,11b
   jne     @f
   movups  xmm0,[esi]
   movups  [edi],xmm0
   add     edi,12
   inc     .cntt
  @@:
   add     esi,12
   dec     ecx
   jnz     .l

   mov     ecx,.cntt
   cmp     ecx,[triangles_count_var]
   je      @f
   mov     [triangles_count_var],ecx
   invoke  VirtualFree,[triangles_ptr],0,MEM_RELEASE
   push    .tri_ptr
   pop     [triangles_ptr]
   jmp     .end
  @@:
   invoke  VirtualFree,.tri_ptr,0,MEM_RELEASE

 .end:

   mov    esp,ebp
   pop    ebp
ret
;===========================================================
mark_inner_vert:
;  Find vertices inside object, or fix sense of normal vectors -
;   - normal vectors of triangles on the cover, not whole inside
;     object, all make positive z cooficient of vect, by changing
;     vertices declaration order in description of triangle.
;
;  in:  intialised triangles and vertices list
;       eax first bit = 1 - fix normals, otherwise find ins vert.
;
;  out:  if and eax,1 = 0
;            ecx   - inside vertices number
;            ebx   - pointer to list, each vertex as bit,
;                    if bit is zeroed, vertex is inside
;        else
;            fixed triangles list need to recalculate normal vectors. -
;              - NOT USED NOW
     push    ebp
     mov     ebp,esp
     shl     eax,31
     push    eax

     .do_fix equ dword[ebp-4]

     prompt  prompt_mark_inn_vr


     xor    ebx,ebx
   .th_l:
     push   ebx
     mov    eax,ebx
     or     eax,.do_fix

     invoke CreateThread,NULL,NULL,mark_inner_vert_th,\
            eax,NORMAL_PRIORITY_CLASS,\
            [ThreadID0+ebx*4]
     shl    ebx,2
     add    ebx,hthread0
     mov    [ebx],eax
     invoke SetThreadPriority,ebx,THREAD_PRIORITY_TIME_CRITICAL
     pop    ebx
     inc    ebx
     cmp    ebx,4
     jne    .th_l

     xor    ebx,ebx
   @@:
     invoke SetThreadAffinityMask,[hthread0+ebx*4],0 ;1
     inc    ebx
     cmp    ebx,4
     jne    @b

     xor    ebx,ebx
   @@:
     invoke ResumeThread,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b

     invoke WaitForMultipleObjectsEx,4,hthread0,1,-1,0

     xor    ebx,ebx
   @@:
     invoke CloseHandle,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b

   cmp    .do_fix,0
   jne    .aand

   xor    ecx,ecx
 .l1:
   mov    edi,[thread_params]
   push   ecx
   mov    esi,[thread_params+4+4*ecx]
   mov    ecx,[points_count_var]
   shr    ecx,7
   inc    ecx
 @@:
   movdqa xmm0,[esi]
   por    xmm0,[edi]
   movdqa [edi],xmm0
   add    edi,16
   add    esi,16
   loop   @b
   pop    ecx
   inc    ecx
   cmp    ecx,3
   jnz    .l1
   jmp    .count_inside_vert


 .aand:

   xor    ecx,ecx
 .l2:
   mov    edi,[thread_params]
   push   ecx
   mov    esi,[thread_params+4+4*ecx]
   mov    ecx,[points_count_var]
   shr    ecx,7
   inc    ecx
 @@:
   movdqa xmm0,[esi]
   pand   xmm0,[edi]
   movdqa [edi],xmm0
   add    edi,16
   add    esi,16
   loop   @b
   pop    ecx
   inc    ecx
   cmp    ecx,3
   jnz    .l2



;   cmp    .do_fix,0
;   je     .count_inside_vert

   xor    ecx,ecx
  .loop_fix:
   mov    ebx,ecx
   mov    edx,ecx
   shr    ebx,3
   and    edx,111b
   add    ebx,[thread_params]
   bt     [ebx],edx
                        ; if bit is set -> sense
                        ; of norm will be reversed
   jc     .rev
   inc    ecx
   cmp    ecx,[triangles_count_var]
   jnz    .loop_fix
   jmp    .end_fix

  .rev:

   mov    esi,ecx
   imul   esi,[i12]
   add    esi,[triangles_ptr]
   movq   xmm0,[esi]
   pshufd xmm0,xmm0,11100001b
   movq   [esi],xmm0
   inc    ecx
   cmp    ecx,[triangles_count_var]
   jnz    .loop_fix

 .end_fix:
   mov    ecx,4
   xor    edx,edx
   jmp    .free


  .count_inside_vert:

   xor    ecx,ecx
   mov    ebx,[points_count_var]
  .cnt:
   push   ecx
   mov    edx,ecx
   shr    edx,3
   and    ecx,111b
   add    edx,[thread_params]
   bt     [edx],ecx
;   jc     @f
;   inc    ebx
;  @@:
   sbb    ebx,0
   pop    ecx
   inc    ecx
   cmp    ecx,[points_count_var]
   jnz    .cnt



   mov     ecx,3
   mov     edx,4
  .free:
   push    ecx
   push    edx
   mov     edi,[thread_params+edx+ecx*4]
   invoke  VirtualFree ,edi ,0 , MEM_RELEASE
   pop     edx
   pop     ecx
   loop    .free


   cls

   mov    ecx,ebx  ;.in_vert_count
   mov    ebx,[thread_params]; ptr to list


  mov     esp,ebp
  pop     ebp
ret

;======================================================================
mark_inner_vert_th:
; in :  ebx - thread No, if higest bit is set - fix normal vectors sense
;
; out:
;      if .do_fix = 0
;       dword[thread_params+thread No*4] -  ptr to list
;       to inside vertices, if vertex is inside, adjacent bit is zeroed.
;      else
;       dword[thread_params+thread No*4] -  ptr to list
;       to sense norm change mark, if norm of tri would be reversed -
;       bit is set. To do -> make it work correct !!

; Find vertices inside object

   push  ebp
   mov   ebp,esp
   sub   esp,140

   .z_buff        equ dword[ebp-4]
   .inner_vert    equ dword[ebp-8]  ; ptr to desired list
   .in_vert_count equ dword[ebp-12]
   .side0         equ dword[ebp-16]
   .do_fix        equ dword[ebp-20]
   .norm_rot      equ dword[ebp-24]
   .sinx          equ dword[ebp-28]
   .cosx          equ dword[ebp-32]
   .siny          equ dword[ebp-36]
   .cosy          equ dword[ebp-40]
   .sinz          equ dword[ebp-44]
   .cosz          equ dword[ebp-48]
   .points_rot    equ dword[ebp-52]
   .side1         equ dword[ebp-56]
   .side2         equ dword[ebp-60]
   .matrix        equ [ebp-96]
   .cntt          equ [ebp-100]
   .norm_to_rev   equ dword[ebp-104]
;   .vert_to_prj equ dword[ebp-108]
   .start0     equ dword[ebp-112]
   .start1     equ dword[ebp-116]
   .start2     equ dword[ebp-120]
   .end0       equ dword[ebp-124]
   .end1       equ dword[ebp-128]
   .end2       equ dword[ebp-132]
   .step       equ dword[ebp-136]
   .th_no      equ dword[ebp-140]

   mov   .do_fix,ebx
   and   ebx,0xffff
   mov   .th_no,ebx
   shr   .do_fix,31



; Alloc 1000x1000  buffs
   mov     eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .z_buff,eax


   mov     eax,[points_count_var]
   imul    eax,[i12]
   add     eax,30
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .points_rot,eax

   cmp     .do_fix,1
   je     .l0

   mov     eax,[points_count_var]
   add     eax,150
   shr     eax,3
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 @@:
   mov     .inner_vert,eax

   mov     edi,eax
   mov     ecx,[points_count_var]
   shr     ecx,7
   inc     ecx
   pxor    xmm0,xmm0
  @@:
   movdqa  [edi],xmm0
   loop    @b

   jmp     .l1

 .l0:

   cmp     .do_fix,1
   jne     .l1
   mov     eax,[triangles_count_var]
   imul    eax,[i12]
   add     eax,30
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .norm_rot,eax

   mov     ebx,[triangles_count_var]
   add     ebx,150
   shr     ebx,3
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .norm_to_rev,eax

   mov     edi,eax
   mov     ecx,[triangles_count_var]
   shr     ecx,7
   inc     ecx
   pcmpeqd xmm0,xmm0
  @@:
   movdqa  [edi],xmm0
   loop    @b

  .l1:


   mov     ebx,.th_no
   shl     ebx,6


   mov     .start0,ebx
   mov     .end0,ebx
   add     .end0,64
;   mov     .start1,0
;   mov     .start2,0
;   mov     .end1,256
;   mov     .end2,256
   mov     .step,16


; Do paralell projection.
; Render faces - only z coord
  push    .start0
  pop     .side0
;  mov      .side0,0
 .next_side0:
;  push    .start1
;  pop     .side1
  mov      .side1,0
 .next_side1:
;  push    .start2
;  pop     .side2
  mov      .side2,0
 .next_side2:
   fninit
   fld   [one_deg]
   fld   st
   fimul .side0   ; z
   fsincos
   fstp  .sinx
   fstp  .cosx
   fld   st
   fimul .side1 ; x
   fsincos
   fstp  .siny
   fstp  .cosy
   fimul .side2 ; y
   fsincos
   fstp  .sinz
   fstp  .cosz

   pushad
   push   .sinx
   push   .cosx
   push   .siny
   push   .cosy
   push   .sinz
   push   .cosz
   lea    edi,.matrix
   call   make_rotation_matrix
   popad

   cmp    .do_fix,1
   jne    .no_rotn
   push   ebp
   mov    esi,[triangles_normals_ptr]
   mov    edi,.norm_rot
   mov    ecx,[triangles_count_var]
   lea    ebx,.matrix
   call   rotary
   pop ebp



;   mov    edi,.norm_rot
;   mov    ecx,[triangles_count_var]
;   xor    ebx,ebx
;  .calc:
;   bt     dword[edi+8],31
;   jc     @f
;   inc    ebx
;  @@:
;   add    edi,12
;   loop  .calc

;   int3
  .no_rotn:

   lea  esi,.matrix    ;esi - pointer to 3x3 matrix
   mov  ebx,f490x3     ;ebx - ptr to scale
   call add_scale_to_matrix

   push   ebp
   mov    esi,[points_r_ptr]  ; vertices to project
   mov    edi,.points_rot
   mov    ecx,[points_count_var]
   lea    ebx,.matrix
   call   rotary
   pop ebp

   mov     esi,.points_rot
   mov     ecx,[points_count_var]
 @@:
   movups   xmm0,[esi]
   addps    xmm0,[f500x3]
   movhlps  xmm1,xmm0
   cvtps2dq xmm0,xmm0
   pshufd   xmm0,xmm0,11100001b
   movq     [esi],xmm0
   movss    [esi+8],xmm1
   add      esi,12
   loop     @b

   mov     ecx,1020*1020
   mov     edi,.z_buff
   mov     eax,6000.1
   call    fill_aligned

   mov    esi,[triangles_ptr]
   mov    ecx,[triangles_count_var]
  .rd:  ; render
   push   esi
   push   ecx
   mov    eax,[esi]
   mov    ebx,[esi+4]
   mov    ecx,[esi+8]
   imul   eax,[i12]
   imul   ebx,[i12]
   imul   ecx,[i12]
   add    eax,.points_rot
   add    ebx,.points_rot
   add    ecx,.points_rot
   movq   xmm0,[eax]
   movq   xmm1,[ebx]
   movq   xmm2,[ecx]

   movss  xmm3,[eax+8]
   movss  xmm4,[ebx+8]
   movss  xmm5,[ecx+8]

   packssdw xmm0,[the_zero]
   packssdw xmm1,[the_zero]
   packssdw xmm2,[the_zero]
   movd     eax,xmm0
   movd     ebx,xmm1
   movd     ecx,xmm2
   mov      edx,1000 shl 16 + 1000
   movss    xmm0,xmm3
   shufps   xmm4,xmm4,11110011b
   movlhps  xmm0,xmm5
   orps     xmm0,xmm4

   mov    esi,.z_buff
   call   stencil_tri
   pop    ecx
   pop    esi
   add    esi,12
   dec    ecx
   jne    .rd




   cmp      .do_fix,1
   jne      .iv

   mov      esi,[triangles_ptr]
   xor      ecx,ecx
   movss    xmm7,[eps3]  ;                epsilon1]
   shufps   xmm7,xmm7,0
 .check_in:
   push     esi
   push     ecx
   mov      .cntt,ecx     ; tri counter

   mov      ecx,3
 .chckv:
   push     ecx
   push     esi
   mov      edx,[esi]
   imul     edx,[i12]
   add      edx,.points_rot
   movss    xmm0,[edx+8]
;   bt       dword[edx+8],31
;   jc       @f
;   jmp      .check_norm
   shufps   xmm0,xmm0,0
   mov      eax,[edx+4]  ; x coord
   mov      ebx,[edx]    ; y
   dec      eax
   dec      ebx
   imul     ebx,[i1000]
   add      ebx,eax
   shl      ebx,2
   and      ebx,0x3FFFFF
   add      ebx,.z_buff
   ; check adjacent 9 pixels
   movups   xmm1,[ebx]
   movups   xmm2,[ebx]
   add      ebx,4000
   movups   xmm3,[ebx]
   movups   xmm4,[ebx]
   add      ebx,4000
   movups   xmm5,[ebx]
   movups   xmm6,[ebx]


   addps    xmm1,[the_one]  ;xmm7
   subps    xmm2,[the_one]  ;xmm7
   addps    xmm3,[the_one]  ;xmm7
   subps    xmm4,[the_one]  ;xmm7
   addps    xmm5,[the_one]  ;xmm7
   subps    xmm6,[the_one]  ;xmm7
   cmpltps  xmm1,xmm0
   cmpltps  xmm2,xmm0
   cmpltps  xmm3,xmm0
   cmpltps  xmm4,xmm0
   cmpltps  xmm5,xmm0
   cmpltps  xmm6,xmm0
   xorps    xmm2,xmm1
   xorps    xmm3,xmm4
   xorps    xmm5,xmm6
   orps     xmm2,xmm3
   orps     xmm5,xmm2
   movmskps eax,xmm5
   and      eax,111b
   or       eax,eax
   jnz      .check_norm
  @@:
  .end_chckv:
   pop      esi
   pop      ecx
   add      esi,4
   dec      ecx
   jnz      .chckv
  .end_chckt:
   pop      ecx
   pop      esi
   add      esi,12
   inc      ecx
   cmp      ecx,[triangles_count_var]
   jnz      .check_in

   jmp      .end_steps

  .check_norm:


;   mov    edi,.norm_rot
;   mov    ecx,[triangles_count_var]
;   xor    ebx,ebx
;  .calc1:
;   bt     dword[edi+8],31
;   jc     @f
;   inc    ebx
;  @@:
;   add    edi,12
;   loop  .calc1

;   int3



    mov      ecx,.cntt
    imul     ecx,[i12]
    add      ecx,.norm_rot      ; normal of visable tri should be
;    add      ecx,8             ; negative
;    bt       dword[ecx],31
;    jc       .end_chckv
    movups   xmm0,[ecx]
;    int3
    movmskps eax,xmm0
    and      eax,100b
    or       eax,eax
    jnz      .end_chckv

  .revers:   ; mark it need rev

    mov      eax,1
    mov      ecx,.cntt
    mov      edx,.cntt
    shr      edx,3
    and      ecx,111b
    shl      eax,cl
    not      eax
    add      edx,.norm_to_rev
    and      [edx],eax  ; if bit is zero -> sense
                        ; of norm will be reversed
    jmp      .end_chckv

  .iv:

; check if z coord of each vert is  in buff

   mov      esi,.points_rot
   xor      ecx,ecx
   movss    xmm7,[eps3]  ;                epsilon1]
   shufps   xmm7,xmm7,0
 .nxcnt:
   push     ecx
   movss    xmm0,[esi+8]
   shufps   xmm0,xmm0,0
   mov      eax,[esi+4]  ; x coord
   mov      ebx,[esi]    ; y
   dec      eax
   dec      ebx
   imul     ebx,[i1000]
   add      ebx,eax
   shl      ebx,2
   and      ebx,0x3FFFFF
   add      ebx,.z_buff
   ; check adjacent 9 pixels
   movups   xmm1,[ebx]
   movups   xmm2,[ebx]
   add      ebx,4000
   movups   xmm3,[ebx]
   movups   xmm4,[ebx]
   add      ebx,4000
   movups   xmm5,[ebx]
   movups   xmm6,[ebx]

   addps    xmm1,xmm7
   subps    xmm2,xmm7
   addps    xmm3,xmm7
   subps    xmm4,xmm7
   addps    xmm5,xmm7
   subps    xmm6,xmm7
   cmpltps  xmm1,xmm0
   cmpltps  xmm2,xmm0
   cmpltps  xmm3,xmm0
   cmpltps  xmm4,xmm0
   cmpltps  xmm5,xmm0
   cmpltps  xmm6,xmm0
   xorps    xmm2,xmm1
   xorps    xmm3,xmm4
   xorps    xmm5,xmm6
   orps     xmm2,xmm3
   orps     xmm5,xmm2
   movmskps eax,xmm5
;   or       eax,eax
;   jz       @f
;   mov      edx,ecx
;   and      ecx,111b
;   shr      edx,3
;   add      edx,.inner_vert
;   bts     [edx],ecx
   and      eax,111b
   or       eax,eax
   jz       @f
   mov      eax,1
   mov      edx,ecx
   shr      edx,3
   and      ecx,111b
   shl      eax,cl
   add      edx,.inner_vert
;   mov      ebx,[edx]
;   or       ebx,eax
   or       [edx],eax  ; if bit is set vertex is not inside
 @@:
   pop      ecx
   add      esi,12
   inc      ecx
   cmp      ecx,[points_count_var]
   jnz      .nxcnt

  .end_steps:

   mov     ecx,.step
   add    .side2,ecx
;   mov     ebx,.end2
   cmp    .side2,256 ;ebx
   jng    .next_side2

   add    .side1,ecx
;   mov     ebx,.end1
   cmp    .side1,256  ;ebx
   jng    .next_side1

   add    .side0,ecx
   mov     ebx,.end0
   cmp    .side0,ebx
   jng    .next_side0

   mov    ecx,.inner_vert
   cmp    .do_fix,1
   jne    @f
   mov    ecx,.norm_to_rev
 @@:
   mov    ebx,.th_no
   shl    ebx,2
   add    ebx,thread_params
   mov    [ebx],ecx

;   dword[thread_params+th_no] - out parameter - ptr to list
;                                of inside vertices/normals to
;                                reverse senses
;   if vertex is inside, adjacent bit is zeroed/
;   /if bit is set -> sense of norm will be reversed
   cmp      .do_fix,1
   jne      @f
   invoke   VirtualFree ,.norm_rot ,0 , MEM_RELEASE
 @@:
   invoke   VirtualFree ,.points_rot ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE

   cls
   mov    esp,ebp
   pop    ebp
ret


;=======================================================================
rm_inner_faces:
;  remove inside faces, whole face must reside
;  in closed volume of object
   push    ebp
   mov     ebp,esp
   sub     esp,8

   .trii_count equ dword[ebp-4]
   .trii       equ dword[ebp-8]

   xor     ebx,ebx
  .alloc:
    mov     eax,1050*1050*4+65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx],eax

   mov      eax,1050*1050*4+65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+4],eax

   mov      eax,[triangles_count_var]
   add      eax,65536
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+8],eax


   mov      eax,[points_count_var]
   imul     eax,[i12]
   add      eax,30
   invoke   VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or       eax,eax
   jnz      @f
   invoke   MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov      [thread_params+ebx+12],eax


   add      ebx,16
   cmp      ebx,16*4
   jne     .alloc


     mov        eax,rm_inner_faces_th
     xor        edx,edx
     mov        ecx,-1
     call       call_thread1
if 0
     xor    ebx,ebx

   .th_l:
     push   ebx
     invoke CreateThread,NULL,NULL,rm_inner_faces_th,\
            ebx,NORMAL_PRIORITY_CLASS,\
            [ThreadID0+ebx*4]
     shl    ebx,2
     add    ebx,hthread0
     mov    [ebx],eax
     invoke SetThreadPriority,ebx,THREAD_PRIORITY_TIME_CRITICAL
     pop    ebx
     inc    ebx
     cmp    ebx,4
     jne    .th_l

     xor    ebx,ebx
   @@:
     invoke SetThreadAffinityMask,[hthread0+ebx*4],0 ;1
     inc    ebx
     cmp    ebx,4
     jne    @b

     xor    ebx,ebx
   @@:
     invoke ResumeThread,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b

     invoke WaitForMultipleObjectsEx,4,hthread0,1,-1,0

     xor    ebx,ebx
   @@:
     invoke CloseHandle,[hthread0+ebx*4]
     inc    ebx
     cmp    ebx,4
     jne    @b
end if


   mov    ebx,16      ; merge visable triangles list
  .nx_tri_p:          ; next tri list params
   mov    edi,[thread_params+8]
   mov    esi,[thread_params+8+ebx]
   mov    ecx,[triangles_count_var]
  .mv:
   cmp    byte[esi],1
   jne    @f
   mov    al,[esi]
   mov    [edi],al
  @@:
   inc    esi
   inc    edi
   loop   .mv
   add    ebx,16
   cmp    ebx,64
   jne    .nx_tri_p

   mov    esi,[thread_params+8]    ; count visable tris
   mov    ecx,[triangles_count_var]
   xor    ebx,ebx
  .cnt:
   cmp    byte[esi],1
   jne    @f
   inc    ebx
  @@:
   inc    esi
   loop   .cnt
   mov    .trii_count,ebx
   imul   ebx,[i12]
   add    ebx,1024


   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .trii,eax

   mov    ebx,[thread_params+8] ; renew triangles list
   mov    esi,[triangles_ptr]
   mov    edi,.trii
   mov    ecx,[triangles_count_var]
 .move:
   cmp    byte[ebx],1
   jne    @f
   movdqu xmm0,[esi]
   movq   [edi],xmm0
   psrldq xmm0,8
   movd   [edi+8],xmm0
   add    edi,12
  @@:
   add    esi,12
   inc    ebx
   loop   .move

   invoke VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE
   push   .trii
   pop    [triangles_ptr]
   push   .trii_count
   pop    [triangles_count_var]

  xor     ebx,ebx
 @@:
  invoke  VirtualFree,[thread_params+ebx],0,MEM_RELEASE
  add     ebx,4
  cmp     ebx,64
  jne     @b

   cls
   mov   esp,ebp
   pop   ebp
ret

;======================================================================
rm_inner_faces_th:
;  Remove inside faces.
;  Maybye in the future I perform removing faces that have
;  degenerated vertices also.
; in:
;  eax = -1 -> leave only front, otherwise ->
;   -> ebx = thread No
;  edi -> vertices to project
;  in threaded cause :
;   dword[thread_params]    -  .z_buff     - zbuffer
;   dword[thread_params+4]  -  .prj_buff   - project buffer
;   dword[thread_params+8]  -  .tri_buff   - triangles buffer
;   dword[thread_params+12] -  .points_rot - vertices rotated buffer

   push  ebp
   mov   ebp,esp
   sub   esp,136

   .z_buff     equ dword[ebp-4]
   .prj_buff   equ dword[ebp-8]
   .tri_buff   equ dword[ebp-12]
   .side0      equ dword[ebp-16]
   .tri_count  equ dword[ebp-20]
   .tri        equ dword[ebp-24]
   .sinx       equ dword[ebp-28]
   .cosx       equ dword[ebp-32]
   .siny       equ dword[ebp-36]
   .cosy       equ dword[ebp-40]
   .sinz       equ dword[ebp-44]
   .cosz       equ dword[ebp-48]
   .points_rot equ dword[ebp-52]
   .side1      equ dword[ebp-56]
   .side2      equ dword[ebp-60]
   .matrix     equ [ebp-96]
   .tri_buffe  equ [ebp-100]
   .only_front equ dword[ebp-104]
   .vert_to_prj equ dword[ebp-108]
   .start0     equ dword[ebp-112]
   .start1     equ dword[ebp-116]
   .start2     equ dword[ebp-120]
   .end0       equ dword[ebp-124]
   .end1       equ dword[ebp-128]
   .end2       equ dword[ebp-132]
   .step       equ dword[ebp-136]

   mov     .only_front,ebx      ; th_no
   cmp     eax,-1
   jne     @f
   mov     .only_front,eax
  @@:
   mov     .vert_to_prj,edi

   prompt  prompt_inside_fac

   cmp     eax,-1
   jne     .no_crop_front
   mov     ebx,-17
   mov     .start0,ebx
   mov     .start1,ebx
   mov     .start2,ebx
   mov     ebx,17
   mov     .end0,ebx
   mov     .end1,ebx
   mov     .end2,ebx
   mov     .step,16
; Alloc 1000x1000  buffs
   mov     eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .z_buff,eax

   mov     eax,1050*1050*4+65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .prj_buff,eax

   mov     eax,[triangles_count_var]
   add     eax,65536
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri_buff,eax


   mov     eax,[points_count_var]
   imul    eax,[i12]
   add     eax,30
   invoke  VirtualAlloc,NULL,eax,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .points_rot,eax
   jmp     .ff


  .no_crop_front:
   mov     ecx,64
   mov     eax,.only_front   ; th no
   imul    ecx,eax

   xor     ebx,ebx
   mov     .start0,ecx
   mov     .start1,ebx
   mov     .start2,ebx
   mov     ebx,257
   add     ecx,64
   inc     ecx
   mov     .end0,ecx
   mov     .end1,ebx
   mov     .end2,ebx
   mov     .step,32

   shl     eax,4
   add     eax,thread_params
   push    dword[eax]
   pop     .z_buff
   push    dword[eax+4]
   pop     .prj_buff
   push    dword[eax+8]
   pop     .tri_buff
   push    dword[eax+12]
   pop     .points_rot
   mov     edi,[points_r_ptr]
   mov     .vert_to_prj,edi
  .ff:




   mov     ecx,[triangles_count_var]
   mov     edi,.tri_buff
   xor     eax,eax
   shr     ecx,2
   add     ecx,3000
   call    fill_aligned


; Do paralell projection.
; Render faces with index of face as a color.
  push    .start0
  pop     .side0
 .next_side0:
  push    .start1
  pop     .side1
 .next_side1:
  push    .start2
  pop     .side2
 .next_side2:
   fninit
   fld   [one_deg]
   fld   st
   fimul .side0   ; z
   fsincos
   fstp  .sinx
   fstp  .cosx
   fld   st
   fimul .side1 ; x
   fsincos
   fstp  .siny
   fstp  .cosy
   fimul .side2 ; y
   fsincos
   fstp  .sinz
   fstp  .cosz

   pushad
   push   .sinx
   push   .cosx
   push   .siny
   push   .cosy
   push   .sinz
   push   .cosz
   lea    edi,.matrix
   call   make_rotation_matrix
   popad

   push   ebp
;   cmp    .only_front,1
;   je     @f

;   mov    esi,[points_r_ptr]           ; rotate normals
;   jmp    .f
;  @@:
   mov    esi,.vert_to_prj   ; vertices to project
;  .f:
   mov    edi,.points_rot
   mov    ecx,[points_count_var]
   lea    ebx,.matrix
   call   rotary
   pop ebp

   mov     ecx,1000*1000
   mov     edi,.prj_buff
   mov     eax,-1
   call    fill_aligned

   mov     ecx,1000*1000
   mov     edi,.z_buff
   mov     eax,6000.1
   call    fill_aligned

   mov    esi,[triangles_ptr]
   xor    edx,edx
  .rd:  ; render

   push   esi
   push   edx
   push   ebp
   mov    eax,[esi]
   mov    ebx,[esi+4]
   mov    ecx,[esi+8]
   imul   eax,[i12]
   imul   ebx,[i12]
   imul   ecx,[i12]
   add    eax,.points_rot
   add    ebx,.points_rot
   add    ecx,.points_rot
   push   dword 1000     ; x, y prj scr size
   push   dword 1000
   movups xmm0,[eax]
   movups xmm1,[ebx]
   movups xmm2,[ecx]

  .dn:
   mulps  xmm0,[f490x3]
   mulps  xmm1,[f490x3]
   mulps  xmm2,[f490x3]
   addps  xmm0,[f500x3]
   addps  xmm1,[f500x3]
   addps  xmm2,[f500x3]
   movhlps xmm3,xmm0
   movhlps xmm4,xmm1
   movhlps xmm5,xmm2
   movd   ecx,xmm3
   movd   ebx,xmm4
   movd   eax,xmm5
   push   eax
   push   ebx
   push   ecx


   cvtps2dq xmm0,xmm0
   cvtps2dq xmm1,xmm1
   cvtps2dq xmm2,xmm2
   packssdw xmm0,[the_zero]
   packssdw xmm1,[the_zero]
   packssdw xmm2,[the_zero]
   movd   eax,xmm0
   movd   ebx,xmm1
   movd   ecx,xmm2
   mov    esi,.z_buff
   mov    edi,.prj_buff
   call   flat_triangle_z_float
   pop    ebp
   pop    edx
   pop    esi
   add    esi,12
   inc    edx
   cmp    edx,[triangles_count_var]
   jne    .rd

; check if tri index in buff
   mov    esi,.prj_buff
   mov    ecx,1000*1000
 .chck:
   mov    edi,[esi]
   cmp    edi,[triangles_count_var]
   jae    @f
   cmp    edi,-1
   je     @f
   add    edi,.tri_buff
   mov    byte[edi],1    ; 1 - tri outside, 0 - inside
  @@:
   add    esi,4
   loop   .chck

   mov     ecx,.step
   add    .side2,ecx
   mov     ebx,.end2
   cmp    .side2,ebx
   jng    .next_side2

   add    .side1,ecx
   mov     ebx,.end1
   cmp    .side1,ebx
   jng    .next_side1

   add    .side0,ecx
   mov     ebx,.end0
   cmp    .side0,ebx
   jng    .next_side0

   cmp    .only_front,-1   ; only front faces ?
   jne    .end

 ;  count triangles outside
   mov    esi,.tri_buff
   mov    ecx,[triangles_count_var]
   xor    ebx,ebx
  .cnt:
   cmp    byte[esi],1
   jne    @f
   inc    ebx
  @@:
   inc    esi
   loop   .cnt
   mov    .tri_count,ebx
   imul   ebx,[i12]
   add    ebx,1024


   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .tri,eax

   mov    ebx,.tri_buff  ; renew triangles list
   mov    esi,[triangles_ptr]
   mov    edi,.tri
   mov    ecx,[triangles_count_var]
 .move:
   cmp    byte[ebx],1
   jne    @f
   movdqu xmm0,[esi]
   movq   [edi],xmm0
   psrldq xmm0,8
   movd   [edi+8],xmm0
   add    edi,12
  @@:
   add    esi,12
   inc    ebx
   loop   .move

   invoke   VirtualFree ,[triangles_ptr] ,0 , MEM_RELEASE
   invoke   VirtualFree ,.tri_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.prj_buff ,0 , MEM_RELEASE
   invoke   VirtualFree ,.z_buff ,0 , MEM_RELEASE


   push   .tri
   pop    [triangles_ptr]
   push   .tri_count
   pop    [triangles_count_var]

   cls
  .end:
   mov    esp,ebp
   pop    ebp

ret


;===============================================================

do_edges_list:
; in:
;  some globals triangles list and whole number
; out:
;  edges list - [edges_ptr]  and edges number -> [edges_count]
    push    ebp
    mov     ebp,esp
    sub     esp,20

    .ed_cnt  equ [ebp-4]
    .ed_ptr  equ [ebp-8]
    .counter equ [ebp-12]
    .ed1_ptr equ [ebp-16]

    prompt  prompt_edges



    invoke  VirtualFree ,[edges_ptr],0 , MEM_RELEASE

    mov     ecx,[triangles_count_var]
    lea     ecx,[ecx*3]
    shl     ecx,4
    add     ecx,536
    invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    or      eax,eax
    jnz     @f
    invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
    mov     .ed1_ptr,eax

    mov     ecx,[triangles_count_var]
    lea     ecx,[ecx*3]
    shl     ecx,4
    add     ecx,536
    invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
    or      eax,eax
    jnz     @f
    invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
    mov     .ed_ptr,eax
    mov     [edges_ptr],eax






    xchg    ebx,eax
    mov     eax,[triangles_ptr]
    mov     ecx,[triangles_count_var]
  @@:
    movdqu  xmm0,[eax]
    movq    [ebx],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+8],xmm0
    pshufd  xmm0,xmm0,11001001b
    movq    [ebx+16],xmm0
    add     ebx,24
    add     eax,12
    loop    @b

if 0  ; sse 4

    mov     ebx,[edges_ptr]
    mov     ecx,[triangles_count_var]
    mov     edx,ecx
    and     edx,1b
    shr     ecx,1
  @@:
    movdqa    xmm0,[ebx]
    pshufd    xmm0,xmm0,10110001b
    movdqa    xmm1,xmm0
    pmaxud    xmm0,[ebx]
    pminud    xmm1,[ebx]
    pshufd    xmm0,xmm0,11111000b
    pshufd    xmm1,xmm1,11111000b
    punpckldq xmm1,xmm0
    movdqa    [ebx],xmm1
    add       ebx,16
    loop      @b

    cmp       edx,1
    jne       @f
    movq      xmm0,[ebx]
    pshufd    xmm0,xmm0,11100001b
    movdqa    xmm0,xmm1
    pmaxud    xmm0,[ebx]
    pminud    xmm1,[ebx]
    punpckldq xmm1,xmm0
    movq      [ebx],xmm1
  @@:
end if




    mov     ebx,[edges_ptr]
    mov     ecx,[triangles_count_var]
    lea     ecx,[ecx*3]
  .mxd:
    mov     eax,[ebx]
    mov     edx,[ebx+4]
    cmp     eax,[ebx+4]
    cmovg   eax,edx
    cmovg   edx,[ebx]
    mov     [ebx],eax
    mov     [ebx+4],edx
    add     ebx,8
    loop    .mxd



 ;   dbg_ptr [edges_ptr]



   mov      esi,[edges_ptr]
   mov      edi,.ed1_ptr
   mov      ecx,[triangles_count_var]
   lea      ecx,[ecx*3]
   call     sort_hybrid1

if 0

 ;  dbg_ptr [edges_ptr]



   movd    xmm5,esp


   mov     esp,.ed1_ptr
   mov     ecx,[triangles_count_var]
   lea     ecx,[ecx*3]
   shl     ecx,4
   add     esp,ecx

   mov   eax,1
   mov   ebx,[triangles_count_var]
   lea   ebx,[ebx*3]
   dec   ebx
   movd  xmm7,[edges_ptr]
   call  qsort_hybrid


   movd   esp,xmm5

end if
;   dbg_ptr [edges_ptr]
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  sort metod make diifference in edges count, whats up?
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

   invoke   VirtualFree ,.ed1_ptr ,0 , MEM_RELEASE

if 0
   ; sort to be sure
   ; insert sort

   mov    ebx,[edges_ptr]
   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]

   mov    esi,ecx
   shl    esi,3
   add    esi,ebx
   dec    ecx

 .ccc:
   mov    eax,[ebx+8]
   cmp    eax,[ebx]
   jae    .g
   movq   xmm0,[ebx+8]
   push   ebx
 .c:
   cmp    ebx,esi
   jae    .done
   cmp    ebx,.ed_ptr
   jb     .done
   cmp    eax,[ebx]
   jae    .done
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7
   sub    ebx,8
   jnz    .c
   add    ebx,8
 .done:
   movq   [ebx+8],xmm0
 .p:
   pop    ebx
 .g:
   add    ebx,8
   loop   .ccc
end if

;     dbg_ptr [edges_ptr]


  ; insert sort again
   mov    ebx,[edges_ptr]
   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3]
   mov    esi,ecx
   shl    esi,3
   add    esi,ebx

 .count:
   push   ecx
   push   ebx
   xor    ecx,ecx
   mov    eax,[ebx]          ; count
 .aa:
   inc    ecx
   add    ebx,8
   cmp    ebx,esi
   jae    .br         ; break
   cmp    eax,[ebx]
   je     .aa
   mov    .counter,ecx
   pop    ebx
   mov    edi,ebx
   sub    edi,8
   mov    edx,[ebx+8]
 .ccc2:

   cmp    ebx,esi
   jbe    @f
   add    esp,4
   jmp    .ff
 @@:
   mov    eax,[ebx+12]
   mov    edx,[ebx+8]
   cmp    eax,[ebx+4]
   jge    .g2
   movq   xmm0,[ebx+8]
   push   ebx
 .c2:
   cmp    eax,[ebx+4]
   jae    .done2
   movq   xmm7,[ebx]
   movq   [ebx+8],xmm7

   sub    ebx,8
   cmp    ebx,edi
   jz     @f
   cmp    [ebx+8],edx
   jz     .c2
 @@:
 .done2:
   add    ebx,8
   movq   [ebx],xmm0

 .p2:
   pop    ebx
 .g2:
   add    ebx,8
   dec    ecx
   cmp    ecx,1
   jnz    .ccc2

   pop    ecx
   sub    ecx,.counter
   add    ebx,8
   ja     .count

   jmp    .ff
 .br: ;break
   add   esp,8
 .ff:





 ;   count edges

   mov    ecx,[triangles_count_var]
   lea    ecx,[ecx*3+3]
   mov    esi,[edges_ptr]
   xor    edx,edx
   cld
 .nx:
   lodsd
   mov    ebx,[esi]
   add    esi,4
   cmp    eax,[esi]
   jnz    .ic
   cmp    ebx,[esi+4]
   jnz    .ic
   loop   .nx
   jmp    .endc
 .ic:

   inc    edx
   loop   .nx
  .endc:
    mov     .ed_cnt,edx
    mov     ecx,edx





   mov     ecx,.ed_cnt
   shl     ecx,3
   add     ecx,65536
   invoke  VirtualAlloc,NULL,ecx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke  MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
  @@:
   mov     .ed_ptr,eax




   mov      ebx,[edges_ptr]
   mov      ecx,[triangles_count_var]
   lea      ecx,[ecx*3]
   add      ecx,ecx
  .seek:
   movq     xmm0,[ebx]
   movq     xmm1,[ebx+8]
   pcmpeqd  xmm1,xmm0
   pmovmskb edx,xmm1
   and      edx,0xff
   cmp      edx,0xff
   je       @f
   movq     [eax],xmm0
   add       eax,8
 @@:
   add      ebx,8
   loop     .seek


   invoke   VirtualFree ,[edges_ptr] ,0 , MEM_RELEASE

   mov      eax,.ed_ptr
   mov      ecx,.ed_cnt
   mov      [edges_ptr],eax
   mov      [edges_count],ecx


   cls

   mov      esp,ebp
   pop      ebp
ret


;===========================================================================

remove_redundant_vert:    ; remove redundand vertices
; in:                     ; merge some vertices from teslate area
;     registers:
;        eax - approximation tolerancy (as dword float)
;        ebx - mask - if z coord is importand = 111b, if not imp = 11b
;        ecx - if = 0  check if  merged vertices should be in triangulize area
;              "standard" verts removing
;              if = 1  no checking
;
;     globals:
;        points_r_ptr, triangles_ptr, points_normals_ptr
;        points_count_var, triangles_count_var
; out:
;     recomputed vertices (points) and faces (triangles) list
   push ebp
   mov  ebp,esp
   sub  esp,80
   and  ebp,-16

   .mask                 equ dword[ebp-4] ; ptr to new vertices (each have its old index)
   .tri_ch               equ [ebp-8]
   .t_ptr                equ [ebp-12]
   .counter              equ dword[ebp-16]
   .aprox_vert           equ [ebp-32]     ; tolerancy
   .aprox_norm           equ [ebp-48]
   .mask2                equ dword[ebp-52]
   .msk3                 equ dword[ebp-56]
   .chckk                equ dword[ebp-60]

    ; set approximation tolerancy

   movd    xmm7,eax
   shufps  xmm7,xmm7,0
   movaps  .aprox_vert,xmm7
 ;  mov     ebx,11b
 ;  mov     ecx,111b
 ;  cmp     [Z_care_flag],0
 ;  cmovne  ebx,ecx
   mov     .msk3,ebx
   mov     .chckk,ecx

   prompt  prompt_red_vert


   ; alloc mem for mask
   mov     ebx,[points_count_var]
   shr     ebx,3
   add     ebx,120
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .mask,eax

;   mov     ebx,.points_count_var
;   shr     ebx,3
;   lea     eax,[ebx+120]
   invoke  VirtualAlloc,NULL,ebx,MEM_COMMIT+MEM_RESERVE,PAGE_EXECUTE_READWRITE
   or      eax,eax
   jnz     @f
   invoke MessageBox,NULL,_error_mem,NULL,MB_ICONERROR+MB_OK
 ;  int3
 @@:
   mov    .mask2,eax



   mov      edi,.mask       ; bit mask
   mov      ecx,[points_count_var]
   shr      ecx,3+4
   inc      ecx
   pxor     xmm0,xmm0
 @@:
   movdqa   [edi],xmm0
   add      edi,16
   loop     @b


   mov      edi,.mask2       ; bit mask
   mov      ecx,[points_count_var]
   shr      ecx,3+4
   inc      ecx
   pxor     xmm0,xmm0
 @@:
   movdqa   [edi],xmm0
   add      edi,16
   loop     @b



   mov      eax,1            ; export esi, edi
   mov      ebx,0x33333333   ; only pivot
   call     detect_chunks
;      esi - tri_ch    ; vertices with triangles list
;      edi - t_ptr     ; pointers to tri_ch list
   mov      .tri_ch,esi
   mov      .t_ptr,edi

 ; check if in triangulize(teslate) area

   cmp      .chckk,1
   je       .nochck

   mov      esi,[points_rotated_ptr]
   xor      ecx,ecx
   movlps   xmm7,[tri_area_x1]
   movlps   xmm6,[tri_area_x2]
 .chck:

   movups   xmm0,[esi]
   movups   xmm1,[esi]
   cmpltps  xmm1,xmm7
   cmpltps  xmm0,xmm6
   xorps    xmm0,xmm1
   movmskps eax,xmm0
   and      eax,11b
   cmp      eax,11b
   je       .yes
   mov      edi,ecx
   mov      eax,ecx
   shr      edi,3
   and      eax,111b
   add      edi,.mask
   bts      dword[edi],eax
  .yes:
   add      esi,12
   inc      ecx
   cmp      ecx,[points_count_var]
   jne      .chck

  .nochck:




   mov      esi,[points_rotated_ptr]
   mov      .counter,0
  .nx_a1:
   push     esi

   mov      edi,.counter
   mov      eax,.counter
   shr      edi,3
   and      eax,111b
   add      edi,.mask
   bt       dword[edi],eax
   jc       .nx_a

   movups   xmm6 ,[esi]
   movaps   xmm7,xmm6
   subps    xmm6,.aprox_vert
   addps    xmm7,.aprox_vert


   mov      ebx,[points_rotated_ptr]
   xor      ecx,ecx
;  mov        ecx,.counter
;  dec        ecx
;  mov        ebx,ecx
;  imul       ebx,[12]
;  add        ebx,[points_rotated_ptr]
 .nx_b1:
   push     ebx
   cmp      ecx,.counter
   je       .nx_b
   mov      edi,ecx
   mov      eax,ecx
   shr      edi,3
   and      eax,111b
   add      edi,.mask
   bt       dword[edi],eax
   jc       .nx_b

   movups   xmm1,[ebx]
   movups   xmm0,[ebx]
   cmpltps  xmm1,xmm6
   cmpltps  xmm0,xmm7
   xorps    xmm0,xmm1
   movmskps eax,xmm0
   and      eax,.msk3  ;11b
   cmp      eax,.msk3  ;11b
   je       .rem_v_in

 .nx_b:
   pop      ebx
   add      ebx,12
   inc      ecx
   cmp      ecx,[points_count_var]
   jne     .nx_b1

 .nx_a:
   pop      esi
   inc      .counter
   add      esi,12
   mov      ecx,[points_count_var]
   cmp      .counter,ecx
   jne      .nx_a1

   cmp      .chckk,1
   je       .done


 ;  cmp     [points_count_var],40000
 ;  jna      .rm_unu_vert
   jmp      .via_ch          ; remove unuse vert via chunks proc





 .rem_v_in:                 ; remove vert index
   push    ecx

   mov     edi,ecx
   mov     ebx,ecx
   shl     edi,2
   add     edi,.t_ptr
   mov     edi,[edi]
 .l1:
   mov     esi,[edi+4]       ; edi - tri  index
;   cmp     ebx,[edi]         ; ebx - vert index,
;   je      @f
;   int3
;  @@:


   imul    esi,[i12]
   add     esi,[triangles_ptr]
   mov     ecx,3            ; fix
 @@:
   mov     eax,[esi]
   cmp     eax,ebx
   cmove   eax,.counter
   mov     [esi],eax
   add     esi,4
   loop    @b
   add     edi,8
   cmp     [edi],ebx
   je      .l1
   pop     ecx
   mov     ebx,ecx
   mov     edx,ecx
   and     ebx,111b
   shr     edx,3
   push    edx
   add     edx,.mask
   bts     dword[edx],ebx
   pop     edx
   add     edx,.mask2
   bts     dword[edx],ebx
   jmp     .nx_b



 .rm_unu_vert:

; remove verts that was removed
  xor     ecx,ecx
 .nx1:
  mov     eax,ecx
  mov     ebx,ecx
  shr     ebx,3
  and     eax,111b
  add     ebx,.mask2
  bt      dword[ebx],eax
  jc      .rm

 .nx2:
  inc     ecx
  cmp     ecx,[points_count_var]
  jne     .nx1

  jmp     .done




 .rm:           ; fix lists
  push    ecx

  mov     ebx,ecx
  inc      ecx

  mov     esi,ecx
  imul    esi,[i12]
  add     esi,[points_r_ptr]
  lea     edi,[esi-12]
 @@:
  movq    xmm0,[esi]
  movd    xmm1,[esi+8]
  movq    [edi],xmm0
  movd    [edi+8],xmm1
  add     edi,12
  add     esi,12
  inc     ecx
  cmp     ecx,[points_count_var]
  jne     @b


  mov     esi,[triangles_ptr]
  mov     ecx,[triangles_count_var]
  lea     ecx,[ecx*3]
 .fixx:
  cmp     [esi],ebx
  jng     @f
  dec     dword[esi]
  @@:
  add     esi,4
  loop    .fixx


  pop     ecx
  dec     [points_count_var]
  jmp     .nx2


 .via_ch:                    ; fix using detect chunks (try)

   xor      eax,eax          ; non export esi, edi
   mov      ebx,0x33333333   ; only pivot and rm unused vert
   call     detect_chunks    ; rm unused vert



 .done:

  invoke   VirtualFree ,.mask2 ,0 , MEM_RELEASE
  invoke   VirtualFree ,.mask ,0 , MEM_RELEASE
  invoke   VirtualFree ,.tri_ch ,0 , MEM_RELEASE
  invoke   VirtualFree ,.t_ptr ,0 , MEM_RELEASE

  cls      ;macro
  add      esp,80
  pop      ebp
ret

;===========================================================================
draw_triangulize_rect:
    ;at 1st clear teslate area buff
    xor   eax,eax          ; clear
    mov   edi,[edit_tri_area_ptr]
    movzx ebx,[xres_var]
    movzx ecx,[yres_var]
    imul  ecx,ebx
    shr   ecx,4
    call  fill_aligned

    movups    xmm0,dqword[tri_area_x1]
    cvtps2dq  xmm0,xmm0
    shufps    xmm0,xmm0,11011000b
    packssdw  xmm0,xmm0
    movd      eax,xmm0
    psrldq    xmm0,4
    movd      ebx,xmm0

    movd     mm1,[screen_ptr]
    pxor     xmm6,xmm6
   ;  movd     mm0,[Zbuffer_ptr]
    movzx    ecx,[xres_var]
    movd     mm2,ecx
    mov      ecx,0x0000ff00
    movd     mm3,ecx
    movd     xmm7,[xres_vard]
    punpcklwd xmm7,xmm6
    call      write_framee
    mov       ecx,1         ; other const mark
    movlps    xmm0,qword[tri_area_x1]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area

    mov       ecx,0
    movlps    xmm0,qword[tri_area_x2]
    movzx     edx,[xres_var]
    sub       edx,4
    movzx     esi,[yres_var]
    sub       esi,4
    call      bar_tri_area
ret

;============================================================
bar_tri_area:
 ;  ecx - signature - 0 / 1
 ;  xmm0 - coordinates
 ;  edx  - yresm4
 ;  esi  - xresm4
    push     ebp
    mov      ebp,esp

    .xresm4   equ ebp-4
    .yresm4   equ ebp-8
    .ed       equ ebp-12
    .add_tb   equ ebp-16
    .add      equ ebp-20

    push     edx
    push     esi
    push     ecx
    movzx    eax,[xres_var]
    sub      eax,6
;    shl      eax,2
    push     eax
    shl      eax,2
    push     eax

    cvtps2dq xmm0,xmm0
    movd     eax,xmm0
    psrldq   xmm0,4
    movd     ebx,xmm0
    cmp      eax,5
    jle      .skip
    cmp      ebx,5
    jle      .skip
    cmp      ebx,dword[.yresm4]
    jge      .skip
    cmp      eax,dword[.xresm4]
    jge      .skip

    sub      eax,3
    sub      ebx,3
    xchg     eax,ebx
    movzx    edx,[xres_var]
    mul      edx
    add      ebx,eax
    mov      eax,ebx
    shl      eax,2
    mov      edi,eax
    add      edi,[screen_ptr]
    and      dword[.ed],1b
  ;  draw bar 6x6
    mov      eax,6

 .oop_ed:
    push     eax
    mov      eax,6
  .oop1:
    push     ebx
    mov      ecx,ebx
    shr      ebx,2
    and      ecx,11b
    add      ebx,[edit_tri_area_ptr]
    mov      dword[edi],0x00ffff00
    add      ecx,ecx
    inc      ecx
    cmp      dword[.ed],0
    jne      @f
    bts      [ebx],ecx
    jmp      .f
  @@:
    inc      ecx
    bts      [ebx],ecx
  .f:
    pop      ebx
    add      ebx,1
    add      edi,4
    dec      eax
    jnz      .oop1
    add      edi,[.add]
    add      ebx,[.add_tb]
    pop      eax
    dec      eax
    jnz     .oop_ed
  .skip:
   mov       esp,ebp
   pop       ebp
ret


;==========================================================
calc_shadow:  ; calc shadow 4X4 matrix
 ; in esi -> light vector - ptr to 3 dwords float
 ;    ebx -> ptr to 4x4 shadow matrix 16 dwords, 64 bytes
 movups xmm1,[plane_equation]
 movups xmm0,[esi]
 andps  xmm0,[zero_hgst_dd]
 orps   xmm0,[one_hgst_dd]
 movaps xmm2,xmm0  ; xmm2 light vector
 mulps  xmm0,xmm1
 haddps xmm0,xmm0
 haddps xmm0,xmm0
 movaps xmm4,xmm0  ; xmm4 - dot product

 ; do 4x4 shadow matrix
 movss  xmm3,[plane_equation]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx],xmm3
 addss  xmm3,xmm4
 movss  [ebx],xmm3

 movss  xmm3,[plane_equation+4]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+16],xmm3
 shufps xmm3,xmm3,11100001b
 addss  xmm3,xmm4
 movss  [ebx+20],xmm3

 movss  xmm3,[plane_equation+8]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+32],xmm3
 shufps xmm3,xmm3,11000110b
 addss  xmm3,xmm4
 movss  [ebx+40],xmm3

 movss  xmm3,[plane_equation+12]
 shufps xmm3,xmm3,0
 mulps  xmm3,xmm2
 movups [ebx+48],xmm3
 shufps xmm3,xmm3,00100111b
 addss  xmm3,xmm4
 movss  [ebx+60],xmm3      ; finaly matrix done
ret
;=================================================================

if 0
calc_p_light_coords:
; in   - none
; out  - xmm1 -> light position
; uses - edx, xmm0, xmm1, xmm3
    movups   xmm0,[point_light]   ;     calculate light coords.
    movzx    edx,[xres_var]
    cvtsi2ss xmm1,edx
    shufps   xmm1,xmm1,11000000b
    mulps    xmm1,xmm0

    movdqu   xmm3,[xxadd]
    cvtdq2ps xmm3,xmm3
    subps    xmm1,xmm3
  ;  addps    xmm1,xmm1      ; xmm1 - first point light position
    movups   [point_light_coords],xmm1
ret
end if
;==============================================
xy_in_rect:

 ; in:
 ; eax - current y shl 16 + x
 ; ecx - y1 shl 16 + x1
 ; edx - y2 shl 16 + x2
 ;out:
 ; ebx = 0 no, ebx = 1 yes
  movd     xmm0,eax
  movd     xmm1,ecx
  movd     xmm2,edx
  pcmpgtw  xmm1,xmm0
  pcmpgtw  xmm2,xmm0
  pxor     xmm2,xmm1
  pmovmskb ebx,xmm2
  cmp      ebx,1111b
  jne     .end_no
  mov     ebx,1
  ret
 .end_no:
  xor  ebx,ebx
ret

;===========================================================
move_texture:
 ;  eax - move x
 ;  ebx - move y
    push ebp

    .x_tex   equ  [ebp-6]
    .y_tex   equ  [ebp-4]
    mov   ebp,esp
    sub   esp,64
    mov   .x_tex,ax
    mov   .y_tex,bx
    cmp   ebx,0
    je    .xx
    jl    .ysub      ;jl

    mov   eax,ebx
    mov   edx,TEX_X
    mul   edx
    mov   ebx,eax
    shl   ebx,2
    lea   esi,[texmap+ebx]
    lea   edi,[texmap]
  ;  cld
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  ;  rep   movsd
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   esi,4
    add   edi,4
    sub   ecx,1
    jnz   @b
    jmp   .xx
 .ysub:
    mov   esi,texmap
    add   esi,TEX_X*TEX_Y*4
    mov   edi,esi
    neg   ebx
    mov   eax,TEX_X
    mul   ebx
    lea   ecx,[eax*4]
    sub   esi,ecx
  ;  std
    mov   ecx,TEX_X*TEX_Y
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    sub   ecx,1
    jnz   @b
 ;   rep   movsd
  .xx:
    cmp   word .x_tex,0
    je    .end
    jl    .xadd
    movzx eax,word .x_tex
 ;   neg   eax
    lea   edx,[eax*4]
  ;  cld
    xor   ebx,ebx
    lea   esi,[texmap+edx]
    lea   edi,[texmap]
  .next_xsub_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    add   edi,4
    add   esi,4
    loop  @b
   ; rep   movsd

    add   esi,edx
    add   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .next_xsub_l
    jmp   .end

   .xadd:

    movsx eax, word .x_tex
    neg   eax

    lea   edx,[eax*4]
  ;  std
    xor   ebx,ebx
    lea   esi,[texmap+TEX_X*TEX_Y*4]
    mov   edi,esi
    sub   esi,edx
  @@:
 .nextxadd_l:
    mov   ecx,TEX_X
    sub   ecx,eax
  @@:
    push  dword[esi]
    pop   dword[edi]
    sub   esi,4
    sub   edi,4
    loop  @b
  ;  rep   movsd
    sub   esi,edx
    sub   edi,edx
    add   ebx,1
    cmp   ebx,TEX_Y
    jne   .nextxadd_l;@b

  .end:
   mov    esp,ebp
   pop   ebp
ret
;==============================================================
apply_displacement_from_tex:
.vert1_ptr equ dword[ebp-4]
.vert2_ptr equ dword[ebp-8]
.vert3_ptr equ dword[ebp-12]
.fact      equ [ebp-16]

        push  ebp
        mov   ebp,esp
        sub   esp,16


        cvtsi2ss xmm5,[displac_div]
        rcpss    xmm5,xmm5
        movss    .fact,xmm5


        prompt prompt_displ
        xor    ecx,ecx
      .next_vert:
        push   ecx                      ; ecx - vertex counter
        mov    ebx,ecx
        imul   ebx,[i12]
        mov    edi,ebx
        add    edi,[points_normals_rotated_ptr]
        add    ebx,[points_r_ptr]
        movups xmm0,[ebx]
        mov    .vert1_ptr,ebx

        mov    esi,ecx
        mov    eax,ecx
        shl    eax,2
        add    eax,[tex_points_ptr]
        mov    ecx,eax
        movzx  eax,word[eax+2] ; tex y
        mov    edx,TEX_X
        mul    edx
        movzx  ecx,word[ecx]   ; tex x
        add    ecx,eax
        shl    ecx,2
        add    ecx,texmap
        mov    eax,ecx
        mov    ecx,[ecx]
        and    ecx,0x00ffffff
        cmp    ecx,[displ_transparent_col]  ;0x00ffffff
        je     .no  ; no change if transparent - white color
        cmp    [td_wp_flag],0  ; only vertices with positive normal z
                               ; cooficient are computed or all vertices ?
        jz     .whole
        test   dword[edi+8],0x80000000   ; check sign of z coof
        jz     .no
      .whole:
        movzx  ecx,byte[eax]   ; read R,G,B pixel
        movzx  ebx,byte[eax+1]
        add    ecx,ebx
        movzx  ebx,byte[eax+2]
        add    ecx,ebx



        mov    eax,esi
        imul   eax,[i12]
        add    eax,[points_normals_ptr]
        movups xmm7,[eax]
        cvtsi2ss xmm6,ecx

        mulss   xmm6,.fact
        shufps  xmm6,xmm6,0

        mulps   xmm7,xmm6
        addps   xmm0,xmm7
        mov     ebx,.vert1_ptr
        movlps  [ebx],xmm0
        movhlps xmm0,xmm0
        movss   [ebx+8],xmm0
      .no:

        pop    ecx
        inc    ecx
        cmp    ecx,[points_count_var]
        jnz    .next_vert
        cls
        mov    esp,ebp
        pop    ebp

ret


;===========================================================

load_tetrahedron:

    mov   esi,tetra_points_r
    mov   edi,[points_r_ptr]
    cld
    fninit
    mov   ecx,tetra_points_count*3 + 1
  @@:
    rep   movsd
;    fild  word[esi]
;    fstp  dword[edi]
;    add   esi,2
;    add   edi,4
;    loop  @b
;    movsd

    mov   esi,tetra_triangles
    mov   edi,[triangles_ptr]
    mov   ecx,tetra_triangles_count*12 + 2
  @@:
    movzx eax,word[esi]
    mov   [edi],eax
    add   esi,2
    add   edi,4
    loop  @b
   ; rep   movsw


    mov   ecx,tetra_triangles_count * 12 + 1
    mov   esi,tetra_tex_points
    mov   edi,[tex_points_ptr]
    rep   movsd

    mov  [triangles_count_var],tetra_triangles_count
    mov  [points_count_var],tetra_points_count
ret

;================================================================
blur_screen:
;blur n times  ; blur or fire
;in - ecx  times count

.counter1 equ dword[esp-8]

         push       ebp
         mov        ebp,esp
         movaps     xmm5,[blur_sub]
     .again_blur:
         push       ecx
         mov        edi,[screen_ptr]
         movzx      ecx,[xres_var]  ;SIZE_X
         xor        eax,eax
         rep        stosd
;         add        edi,16
;         and        edi,-16
         movzx      ecx,[xres_var]  ;SIZE_X
         movzx      ebx,[yres_var]  ;SIZE_X
         sub        ebx,4
         imul       ecx,ebx
         shr        ecx,2
         movzx      ebx,[xres_var]  ;SIZE_X
  ;       mov        ecx,(SIZE_X*(SIZE_Y-4))*4/16
         mov        esi,edi
         mov        edx,ebx
         shl        edx,2
         sub        esi,edx
     .blr:
     @@:
         movaps     xmm0,[edi+ebx*4]
     ;    movaps     xmm1,[esi];[edi-ebx*4]
         movaps     xmm2,[edi-16]
     ;    movaps     xmm3,[edi+16]

         pavgb      xmm0,[esi]
         pavgb      xmm2,[edi+16]
         pavgb      xmm0,xmm2

         psubusb    xmm0,xmm5  ; importand if fire

         movaps     [edi],xmm0
         add        edi,16
         add        esi,16

         loop       .blr

         xor        eax,eax
         movzx      ecx,[xres_var] ;SIZE_X
         rep        stosd
         pop        ecx
         loop       .again_blur
         mov        esp,ebp
         pop        ebp
ret
;===========================================================
normalize_object1:  ; procedure don't save registers !!
; do mesh coords in from -1.0 to 1.0
; in:   stack 1 - vertices count to normalise
;       stack 2 - pointer to vertices
; out:  xmm7 - broadcasted reciprocal of maxscale
;       xmm0 - center

        .points_count equ ebp+4
        .points_r     equ ebp+8

       mov   ebp,esp
       mov  ecx,[.points_count]
       sub  ecx,1
       mov  edi,[.points_r]

       movups  xmm0,[edi]
       movups  xmm2,[edi]
     @@:
       movups  xmm1,[edi+12]
       maxps   xmm0,xmm1
       minps   xmm2,xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b
       movaps  xmm3,xmm0   ; scale
       subps   xmm0,xmm2
       divps   xmm0,[f2x4]
       subps   xmm3,xmm0   ; xmm3 - this we sub from all

       movaps  xmm4,xmm0
       movaps  xmm5,xmm0
       shufps  xmm4,xmm4,11100001b
       shufps  xmm5,xmm5,11000110b
       maxss   xmm4,xmm0
       maxss   xmm4,xmm5    ; xmm4 - max scale
       movss   [max_scale],xmm4
       shufps  xmm4,xmm4,0
       rcpps   xmm4,xmm4

       mov     ecx,[.points_count]
  ;     sub     ecx,1
       mov     edi,[.points_r]
     @@:
       movups  xmm0,[edi]
       subps   xmm0,xmm3    ; set 0,0,0 in center
       mulps   xmm0,xmm4    ; scale
       movhlps xmm1,xmm0
       movlps  [edi],xmm0
       movss   [edi+8],xmm1
       add     edi,12
       sub     ecx,1
       jnz     @b

       movaps  xmm7,xmm4
       movaps  xmm0,xmm3

       mov    esp,ebp

ret 8
;=========================================================
generate_texture1:  ; do blank texture uses for smooth objects edges
       mov  edi,texmap
       mov  eax,0xffffffff
       mov  ecx,TEX_X*TEX_Y
       cld
       rep  stosd
ret
;================================================================
generate_texture3:

       mov  edi,texmap
       xor  ecx,ecx
       cld
     .next:
       xor  ebx,ebx
     @@:
       mov  eax,ecx
       mov  edx,ebx
       xor  eax,edx
       mov  ah,al
       push ax
       shl  eax,8
       pop  ax
;       or   eax,0x00f00000
       ;mov  [edi],eax
       ;add  edi,4
       stosd
       inc  ebx
       cmp  ebx,TEX_X
       jne  @b
       inc  ecx
       cmp  ecx,TEX_Y
       jne  .next
ret
;=============================================================
generate_texture2:
.const equ 32
        cld
        mov     edi,texmap
        xor     bx,bx
     .next_line:
        xor     dx,dx
     .next2stripes:
        mov     eax,-1
        mov     ecx,(TEX_X/.const)
        rep     stosd
        mov     eax,0x00ff0000
        mov     ecx,(TEX_X/.const)
     @@:
        stosd
        loop    @b
        inc     dx
        cmp     dx,.const/2
        jl      .next2stripes
        inc     bx
        cmp     bx,TEX_Y
        jl      .next_line
ret
;============================================================
calc_bumpmap_coords:      ; map texture, bump

      fninit
      fldpi
      fadd      st,st
      mov       esi,[points_r_ptr]
      mov       edi,[tex_points_ptr]
      mov       ecx,[points_count_var]
  ;    inc       ecx

   .again:
      cmp       [map_flag],2
      jg        .spherical
       ; choose map planar or spherical
       ; map flag 1,2,3 - various planar mapping
      cmp      [map_flag],0
      jne      @f
      xor      eax,eax
      mov      ebx,4
      jmp      .do_planar
  @@:
      cmp      [map_flag],1
      jne      @f
      mov      eax,4
      mov      ebx,8
      jmp      .do_planar
  @@:
;      cmp      [map_flag],3
;      jne      @f
      mov      eax,8
      mov      ebx,4
   .do_planar:
   @@:
      fld       dword[esi+eax]
      fimul     [tex_x_div2]   ; planar map
      fiadd     [tex_x_div2]
      fistp     word[edi]

      fld       dword[esi+ebx]
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi+2]

      add      esi,12
      add      edi,4
      loop     .do_planar

      jmp       .end
;      cmp       [map_tex_flag],1
;      jne       .cylindric
   .spherical:
;
;      cmp      [map_flag],3
;      jne      @f
;      xor      eax,eax
;      mov      ebx,4
;      jmp      .do_sp
;  @@:
;      cmp      [map_flag],4
;      jne      @f
;      mov      eax,4
;      mov      ebx,8
;      jmp      .do_sp
;  @@:
;;      cmp      [map_flag],3
;;      jne      @f
;      mov      eax,8
;      mov      ebx,0
;      ; spherical mapping around y axle
;   .do_sp
   @@:
      fld       dword[esi]     ; x coord
      fld       dword[esi+8]   ; z coord
      fpatan                   ; arctg(st1/st)
;      fdiv      .Pi2
      fdiv      st0,st1
      fimul     [tex_x_div2]
      fiadd     [tex_x_div2]
      fistp     word[edi]      ; x

      fld       dword[esi+4]   ; y coord
      fld       dword[esi]     ; x
      fmul      st,st0
      fld       dword[esi+4]   ; y
      fmul      st,st0
      fld       dword[esi+8]   ; z
      fmul      st,st0
      faddp
      faddp
      fsqrt
      fpatan
      fldpi
      fdivp
      fimul    [tex_y_div2]
      fiadd    [tex_y_div2]
      fistp    word[edi+2]     ; y


      add      esi,12
      add      edi,4
      loop     @b
   .end:
      ffree    st0

ret

;================================================================
calc_bumpmap:            ; calculate random bumpmap
;--------------in edi _ pointer to TEX_X x TEX_Y bumpmap

         pushad

         mov     edi, bump_map
         mov     esi,texmap
         mov     ecx,TEXTURE_SIZE
         cmp     [bump_flag],0
         je      .random_bump_map
         ; else bumps according to texture
      @@:
         movzx   ax,byte[esi]
         movzx   bx,byte[esi+1]
         movzx   dx,byte[esi+2]
         add     ax,bx
         add     ax,dx
         cwde
         cdq
         div     [i3]
         stosb
         add     esi,4
         loop    @b
         jmp     .blur_map

  .random_bump_map:

  ;       RDTSC
  ;       mov    [rand_seed],ax
      @@:
         push    ecx
         xor     ecx,ecx
         mov     edx,255
         call    random
         stosb
         pop    ecx
         loop   @b

      .blur_map:

      ;   movzx  ecx,[bumps_deep_flag]
         mov    edi, bump_map
         mov    ecx,4
      .blur:
         xor    esi,esi
         mov    edx,TEXTURE_SIZE
         xor    eax,eax
         xor    ebx,ebx
      @@:
         mov    ebp,esi
         dec    ebp
         and    ebp,TEXTURE_SIZE
         mov    al,byte[ebp+edi]

         mov    ebp,esi
         inc    ebp
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         sub    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         mov    ebp,esi
         add    ebp,TEX_X
         and    ebp,TEXTURE_SIZE
         mov    bl,byte[ebp+edi]
         add    eax,ebx

         shr    eax,2
         mov    byte[esi+edi],al

         inc    esi
         dec    edx
         jnz    @b

         loop   .blur
         popad
ret

;================================================================
make_random_lights:
  .temp1  equ ebp-4
  .temp2  equ ebp-8     ;  - light vector generate variables
  .temp3  equ ebp-12
  .col1   equ ebp-20
  .col2   equ ebp-28
  .col3   equ ebp-32
  .max equ 800
;        RDTSC
;        mov    [rand_seed],ax
        push    ebp
        mov     ebp,esp
        sub     esp,64
        mov     edi,lights
        fninit
        mov     dword[.temp2],.max
        mov     dword[.temp3],.max/2

    .again:
        xor     esi,esi
     @@:
        mov     edx,.max
        xor     ecx,ecx
        call    random
        sub     eax,.max/2
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fidiv   dword[.temp3]
        fstp    dword[edi+esi*4]
        inc     esi
        cmp     esi,2
        jne     @b

  .max1 equ 1000
        mov     dword[.temp2],.max1/2
        mov     edx,.max1
        xor     ecx,ecx
        call    random
        mov     dword[.temp1],eax
        fild    dword[.temp1]
        fchs
        fidiv   dword[.temp2]
        fstp    dword[edi+8]

        xor     esi,esi
     @@:
        mov     ecx,220            ; max colors and shine  , ecx = 200 - more bright shading
        mov     edx,255
        call    random
        movzx   ax,al
        mov     [edi+28+esi*2],ax
        inc     esi
        cmp     esi,4
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,100              ; orginal colors
        movzx   edx,word[edi+28+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+12+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        xor     esi,esi
     @@:
        mov     ecx,1               ; min cols
        movzx   edx,word[edi+12+esi*2]
        call    random
        movzx   ax,al
        mov     [edi+20+esi*2],ax
        inc     esi
        cmp     esi,3
        jne     @b

        add     edi,LIGHT_SIZE ;22
        cmp     edi,lightsend
        jne     .again


        mov       esi,lights
        mov       edi,lights_aligned



     .do_aligned: ; make aligned float lights used
                  ; in all Real Phong rendering models
        movups    xmm0,[esi]
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0    ; normalize
        mulps     xmm1,xmm1
        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1


if 0
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm0,eax
        divss     xmm0,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm1,eax
        divss     xmm1,[f256d]
        mov       ecx,1
        mov       edx,255
        call      random
        sub       eax,128
        cvtsi2ss  xmm2,eax
        divss     xmm2,[f256d]

        shufps    xmm1,xmm1,11100001b
        por       xmm0,xmm1
        movlhps   xmm0,xmm2
        orps      xmm0,[z_minus_mask]
        movaps    xmm1,xmm0
        mulps     xmm1,xmm1

        andps     xmm1,[zero_hgst_dd]
        haddps    xmm1,xmm1
        haddps    xmm1,xmm1
        rsqrtps   xmm1,xmm1
        mulps     xmm0,xmm1
end if


        movq      xmm1,[esi+12]
        movq      xmm2,[esi+12+8]
        movq      xmm3,[esi+12+16]
     ;   psrlw     xmm1,2
        punpcklwd xmm1,[the_zero]
        punpcklwd xmm2,[the_zero]
        punpcklwd xmm3,[the_zero]
        psrld     xmm1,1
        psrld     xmm2,1
      ;  psrld     xmm3,1

        andps     xmm0,[zero_hgst_dd]
        cvtdq2ps  xmm1,xmm1
        cvtdq2ps  xmm2,xmm2
        cvtdq2ps  xmm3,xmm3
        andps     xmm1,[zero_hgst_dd]
        andps     xmm2,[zero_hgst_dd]
        andps     xmm3,[zero_hgst_dd]

        movaps    [edi],xmm0
        movaps    [edi+16],xmm1
        movaps    [edi+32],xmm2
        movaps    [edi+48],xmm3

        add       edi,64
        add       esi,LIGHT_SIZE
        cmp       esi,lightsend
        jne       .do_aligned



        mov     esp,ebp
        pop     ebp
ret
;=======================================================
init_point_lights:
        mov       eax,-1000
        cvtsi2ss  xmm1,eax
        shufps    xmm1,xmm1,11000000b
        mov       esi,lights_aligned
        mov       edi,point_light_coords
        mov       ecx,3
      @@:
        movaps    xmm0,[esi]
        addps     xmm0,[f05x3]
        mulps     xmm0,xmm1
        addps     xmm0,xmm1
        movaps    [edi],xmm0
        add       esi,64
        add       edi,16
        loop      @b
ret

random:
;  in  - ecx - min
;        edx - max
;  out - eax - random number
         mov    bx,[rand_seed]
         add    bx,0x9248
         ror    bx,3
         mov    [rand_seed],bx

         mov    ax,dx
         sub    ax,cx
         mul    bx
         mov    ax,dx
         add    ax,cx
         cwde
ret
;=================================================================
do_color_buffer:         ; do color buffer for Gouraud, flat shading
;env_map 512 x 512 x 3 bytes    ; many lights using
.temp  equ word   [ebp-2]
.nz    equ dword  [ebp-6]  ; dword
.ny    equ dword  [ebp-10]
.nx    equ dword  [ebp-14]
.col_r equ    [ebp-16]
.col_g equ    [ebp-17]
.col_b equ    [ebp-18]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,color_map
         fninit

         mov      dx,- TEX_Y / 2 ;-256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         mov      .temp,cx
         fild     .temp
         fidiv    [tex_x_div2];[i256]st = Nx - vector normal x cooficient
         fst      .nx
         fmul     st,st0
         mov      .temp,dx
         fild     .temp
         fidiv    [tex_y_div2];[i256]st = Ny - vector normal y coeficient
         fst      .ny
         fmul     st,st0
         faddp
         fld1
         fchs
         faddp
         fabs
         fsqrt
         fchs
         fstp     .nz              ; st - Nz - vect normal z coeficient
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         push     edi   ;env_map
         lea      esi,[lights+ebx]
         lea      edi,.nx
         call     dot_product
         pop      edi
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       .env_ok1  ;compare with dot_max
         ffree    st

        jmp       .update_counters
      .env_ok1:
         fcom    dword[dot_max]
         fstsw   ax
         sahf
         jb      .env_ok2     ; calc col
         ffree   st
         jmp     .update_counters
      .env_ok2:            ;calc col
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax         ; earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
  @@:
 .update_counters:                                  ; update and jump when neccesery
        add     ebx,LIGHT_SIZE
        cmp     bx,[all_lights_size]
        jl      .light    ; next_light
        mov     eax,dword .col_b
        stosd

        inc     cx
        cmp     cx,TEX_X / 2 ;256
        jne     .ie_hor

        inc     dx
        cmp     dx,TEX_X / 2 ;256
        jne     .ie_ver

    .env_done:
         mov     esp,ebp
         pop     ebp

ret

;============================================================
init_envmap2:         ; do env_map
;env_map 512 x 512 x 4 bytes
.temp  equ word   [ebp-2]
.nEy   equ word   [ebp-4]
.nEx   equ word   [ebp-6]
.col_r equ        [ebp-8]
.col_g equ        [ebp-9]
.col_b equ        [ebp-10]

         push     ebp
         mov      ebp,esp
         sub      esp,20
         mov      edi,envmap
         fninit

         mov      dx,- TEX_Y / 2 ;256   ; dx - vertical coordinate = y
    .ie_ver:
         mov      cx,- TEX_X / 2 ;256   ; cx - horizontal coord = x
    .ie_hor:
         xor      ebx,ebx
         mov      dword .col_b, 0
     .light:
         lea      esi,[lights+ebx]
         fld      dword[esi]     ; light vector x cooficient
         fimul    [tex_x_div2] ;[i256]
         mov      .temp,cx
         fisubr   .temp
         fistp    .nEx
         fld      dword[esi+4]   ; light vector y cooficient
         fimul    [tex_y_div2] ;[i256]
         mov      .temp,dx
         fisubr   .temp
         fistp    .nEy

         cmp      .nEx,- TEX_X / 2 ;256
         jl       .update_counters
         cmp      .nEy,- TEX_Y / 2 ;256
         jl       .update_counters
         cmp      .nEx,TEX_X / 2 ;256
         jg       .update_counters
         cmp      .nEy,TEX_Y / 2 ;256
         jg       .update_counters

         fild     .nEx
         fmul     st,st0
         fild     .nEy
         fmul     st,st0
         faddp
         fsqrt
         fisubr   [i256]
         fmul     [env_const]
         fidiv    [i256]   ; st - 'virtual' dot product

         fcom     dword[dot_max]
         fstsw    ax
         sahf
         jb       @f
         ffree    st
         fld1     ;[dot_max]
      @@:
         fcom     dword[dot_min]
         fstsw    ax
         sahf
         ja       @f
         ffree    st
         fldz     ;[dot_min]
      @@:
         push     ebp
         push     word[esi+36]   ; -  shines
         push     word[esi+12]   ; b  orginal color
         push     word[esi+14]   ; g
         push     word[esi+16]   ; r
         push     word[esi+28]   ; b  max color
         push     word[esi+30]   ; g
         push     word[esi+32]   ; r
         push     word[esi+20]   ; b  min col
         push     word[esi+22]   ; g
         push     word[esi+24]   ; r
         push     eax            ;    earlier - dot pr
      ;  fstp     .dot_product
      ;  push     .dot_product
         call     calc_one_col
         pop      ebp
         ; eax-0x00rrggbb
         cmp      al,.col_b
         jbe      @f
         mov      .col_b,al
   @@:                        ;  eax - ggbb00rr
         shr      ax,8
         cmp      al,.col_g
         jbe      @f
         mov      .col_g,al
   @@:                        ;  eax - bb0000gg
         shr      eax,16
         cmp      al,.col_r
         jbe      @f
         mov      .col_r,al
   @@:
   .update_counters:                     ; update and jump when neccesery
         add      ebx,LIGHT_SIZE
         cmp      bx,[all_lights_size]
         jl       .light    ; next_light
         mov      eax,dword .col_b
         or        eax,0xff000000
         stosd
     ;    dec      edi

         inc      cx
         cmp      cx,TEX_X / 2 ;256
         jne      .ie_hor

         inc      dx
         cmp      dx,TEX_Y / 2 ;256
         jne     .ie_ver

         mov     esp,ebp
         pop     ebp
ret

;=========================================================
  calc_one_col:
; procedure don't save registers !!!
; in -   st - dot_product
;        stack - other parameters
; out - eax - 0x00rrggbb
.dot_prd   equ dword[ebp+4]           ; dot product   - cos x  - not now
.min_col_r equ word[ebp+8]            ; minimum color - ambient
.min_col_g equ word[ebp+10]
.min_col_b equ word[ebp+12]
.max_col_r equ word[ebp+14]           ; maximum color - specular
.max_col_g equ word[ebp+16]
.max_col_b equ word[ebp+18]
.org_col_r equ word[ebp+20]           ; orginal color - diffuse
.org_col_g equ word[ebp+22]
.org_col_b equ word[ebp+24]
.n         equ word[ebp+26]           ; shines - not implemented
.temp      equ word[ebp-2]
.color_sum_r equ dword[ebp-6]
.color_sum_g equ dword[ebp-10]
.color_sum_b equ dword[ebp-14]
; color = ambient+cos(x)*diffuse+(cos(x)^n)*specular
         mov     ebp,esp
         sub     esp,14

         mov      ax,.min_col_r
         add      ax,.max_col_r
         add      ax,.org_col_r
         cwde
         mov      .color_sum_r,eax

         mov      ax,.min_col_g
         add      ax,.max_col_g
         add      ax,.org_col_g
         cwde
         mov      .color_sum_g,eax

         mov      ax,.min_col_b
         add      ax,.max_col_b
         add      ax,.org_col_b
         cwde
         mov      .color_sum_b,eax


;         fld     .dot_prd
       ;  fild    .n
       ;  fxch    st1
       ;  fabs
       ;  fyl2x                     ;
       ;  f2xm1
       ;  fld1
       ;  faddp        ; st =  dot_product ^ n

         fld     st            ; copy dot pr
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
         cmp     .n,255            ; .n = 255 -> spot light
         jne     @f
         fmul    st,st0
         fmul    st,st0
         fmul    st,st0
      @@:
         fld     st            ; st0=st1=dot_pr^n, st2=dot_pr
         fimul   .max_col_b
         fild    .org_col_b
         fmul    st,st3
         faddp                 ; st0=first piece of col, st1=dot_pr^n..
         fiadd   .min_col_b
         fimul   .max_col_b
         fidiv   .color_sum_b
         fistp   .temp
         movzx   eax,.temp
         shl     eax,16

         fld     st
         fimul   .max_col_g
         fild    .org_col_g
         fmul    st,st3
         faddp
         fiadd   .min_col_g
         fimul   .max_col_g
         fidiv   .color_sum_g
         fistp   .temp
         mov     ax,.temp
         mov     ah,al
         shl     eax,8

         fimul   .max_col_r
         fild    .org_col_r
         fmulp   st2,st
         faddp
         fiadd   .min_col_r
         fimul   .max_col_r
         fidiv   .color_sum_r
         fistp   .temp
         mov     ax,.temp          ;eax -  0xbbgg00rr
     ;   mov     ah,al
         ror     eax,16
         xchg    al,ah             ; eax - 0x00rrggbb
         mov     esp,ebp
ret 24
